angular.module('gurillaApp', ['ionic','gurillaApp.controllers', 'gurillaApp.services','ngCordova','nzTour', 'angularMoment'])

.run(function($ionicHistory,$rootScope,$state,$ionicPlatform,PushProcessing,Contacts,Interests,Channels,Circles,
  Events,LocalData,User,Activity,$interval, $timeout) {
  $ionicPlatform.ready(function() {
     
    if(window.cordova && window.cordova.plugins.Keyboard) {
      window.cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
      // window.cordova.plugins.Keyboard.disableScroll(true);
      window.analytics.debugMode();
      window.analytics.startTrackerWithId('UA-61339418-1');
      window.analytics.trackView('Home Screen');
      window.open = cordova.InAppBrowser.open;
    }


    if (window.cordova) {
       if (navigator.geolocation) {
          navigator.geolocation.watchPosition(function(pos){
            window.localStorage.setItem("coords", 
              JSON.stringify({ 'lat' : pos.coords.latitude ,'long' : pos.coords.longitude }));
          });
       }else{
        console.log('Can not access geo info');
       }
    }
     
    if(window.StatusBar) {
      /* org.apache.cordova.statusbar required */
      StatusBar.styleDefault();
    }

    //TODO: need to specify proper cache folder
    // write log to console
    ImgCache.options.debug = true;

    // increase allocated space on Chrome to 50MB, default was 10MB
    //ImgCache.options.chromeQuota = 10*1024*1024;
    //set cache folder
    if (window.cordova) {
      // ImgCache.options.localCacheFolder = window.cordova.file.cacheDirectory;
    }

    ImgCache.init(function(){
      console.log('ImgCache init: success!');
      
      }, function(){
          console.log('ImgCache init: error! Check the log for errors');
    });
    
    $interval(function(){
      if (Interests.getOnLength()) {
        navigator.geolocation.getCurrentPosition(function(pos){
            var coords = { 'lat' : pos.coords.latitude ,'long' : pos.coords.longitude };
            var prev_coords = JSON.parse(window.localStorage.getItem('coords'));
            if (coords.lat.toPrecision(5) != parseFloat(prev_coords.lat).toPrecision(5) || 
                coords.long.toPrecision(5) != parseFloat(prev_coords.long).toPrecision(5)) {
                User.updateLocation(coords,function(data){
                    window.localStorage.setItem("coords" ,JSON.stringify(coords));
                });
            }
          });
      }
    },1000 * 60 * 10);

    if ((typeof window.localStorage['token'] == 'undefined') || (typeof window.localStorage['account'] == 'undefined')) {
      /* If no token found, go back to the welcome screen for login */
      window.location.href = 'index.html';
    }

    window.addEventListener("offline", function(){
       window.localStorage['ConnectionOnline'] = 'false'; 
    }, false);
    
    window.addEventListener("online", function(){
      window.localStorage['ConnectionOnline'] = 'true';
    }, false);

    $rootScope.showKeyboard = false;
    window.addEventListener('native.keyboardshow', function(){
        $rootScope.showKeyboard = true;
        window.localStorage['showKeyboard'] = true;
    });

    window.addEventListener('native.keyboardhide', function(){
        window.localStorage['showKeyboard'] = false;
     });

    //new way of sync contacts
    if (LocalData.get('newsignup')) {
        Contacts.sync();
    }

  });

  
  Interests.init(function(data){
    $rootScope.interests = data;
  });

  Channels.init(function(data){
    $rootScope.channels = data;
  });

  Events.init(function(data){

  });

  // Activity.init(function(data){
  //   $rootScope.activities = data;
  // });
  

})

.config(function($stateProvider, $urlRouterProvider) {

  /*
  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  */
 
  $stateProvider

  /* setup an abstract state for the tabs directive */

  .state('menu', {
    url: '/menu',
    abstract: true,
    templateUrl: 'templates/menu.html'
  })

  .state('menu.tab', {
    url: "/tab",
    abstract: true,
    views: {
      'menuContent': {
        templateUrl: "templates/tabs.html"
      }
    }
  })

  // .state('menu.tab.activity', {
  //   url: '/activity',
  //   views: {
  //     'tab-activity': {
  //       templateUrl: 'templates/tab-activity.html',
  //       controller: 'ActivityCtrl'
  //     }
  //   }
  // })

  /* Each tab has its own nav history stack: */

  .state('menu.tab.interests', {
    url: '/interests',
    views: {
      'tab-interests': {
        templateUrl: 'templates/tab-interests.html',
        controller: 'InterestsCtrl'
      }
    }
  })
  .state('menu.tab.interest-detail', {
    url: '/interest/:interestId',
    views: {
      'tab-interests': {
        templateUrl: 'templates/interest-detail.html',
        controller: 'InterestDetailCtrl'
      }
    }
  })

  .state('menu.tab.interests-event-detail', {
    "url": "/interests/event/view",
    "cache" : false,
    "params": {
          'id' : 0,
          'data' : {}
    },
    views: {
      'tab-interests': {
        templateUrl: 'templates/event-detail.html',
        controller: 'EventDetailCtrl'
      }
    }
  })

  .state('menu.tab.circles', {
    url: '/circles',
    views: {
      'tab-circles': {
        templateUrl: 'templates/tab-circles.html',
        controller: 'CirclesCtrl'
      }
    }
  })
  .state('menu.tab.circle-create', {
    url: '/circle/create',
    views: {
      'tab-circles': {
        templateUrl: 'templates/circle-create.html',
        controller: 'CircleCreateCtrl'
      }
    }
  })
  .state('menu.tab.circle-create-event', {
    url: '/circle/create/event',
    params : {"type" : null , "object" : null},
    views: {
      'tab-circles': {
        templateUrl: 'templates/event-create.html',
        controller: 'EventCreateCtrl'
      }
    }
  })
  .state('menu.tab.circle-contacts', {
    url: '/circle/contacts',
    views: {
      'tab-circles': {
        templateUrl: 'templates/circle-contacts.html',
        controller: 'CircleContactsCtrl'
      }
    }
  })
  .state('menu.tab.circle-edit', {
    url: '/circle/edit',
    params : {"circle" : null},
    views: {
      'tab-circles': {
        templateUrl: 'templates/circle-edit.html',
        controller: 'CircleEditCtrl'
      }
    }
  })

  .state('menu.tab.account-logout', {
    url: '/circles/account/logout',
    views: {
      'tab-circles': {
        templateUrl: 'templates/login.html',
        controller : "AccountLogoutCtrl"
        
      }
    }
  })
  .state('menu.tab.events', {
    url: '/events',
    params : {"refresh" : false},
    views: {
      'tab-events': {
        templateUrl: 'templates/tab-events.html',
        controller: 'EventsCtrl'
      }
    }
  })
  .state('menu.tab.event-create', {
    url: '/event/create',
    params : {"type" : null , "object" : null},
    views: {
      'tab-events': {
        templateUrl: 'templates/event-create.html',
        controller: 'EventCreateCtrl'
      }
    }
  })
  
  .state('menu.tab.event-detail', {
    url: '/event/view',
    cache : false,
    params:{
      'id' : 0,
      'data' : {}
    },
    views: {
      'tab-events': {
        templateUrl: 'templates/event-detail.html',
        controller: 'EventDetailCtrl'
      }
    }
  })
  .state('menu.tab.event-manage', {
    url: '/event/manage',
    params : {'event' : null},
    views: {
      'tab-events': {
        templateUrl: 'templates/event-manage.html',
        controller: 'EventManageCtrl'
      }
    }
  })
  
  .state('menu.tab.channels', {
    url: '/channels',
    views: {
      'tab-channels': {
        templateUrl: 'templates/tab-channels.html',
        controller: 'ChannelsCtrl'
      }
    }
  })
  .state('menu.tab.channel-create', {
    url: '/channel/create',
    views: {
      'tab-channels': {
        templateUrl: 'templates/channel-create.html',
        controller: 'ChannelCreateCtrl'
      }
    }
  })
  
  .state('menu.tab.channel-create-event', {
    url: '/channel/create/event',
    params : {"type" : null , "object" : null},
    views: {
      'tab-channels': {
        templateUrl: 'templates/event-create.html',
        controller: 'EventCreateCtrl'
      }
    }
  })
  .state('menu.tab.channel-join', {
    url: '/channel/join',
    views: {
      'tab-channels': {
        templateUrl: 'templates/channel-join.html',
        controller: 'ChannelCtrl'
      }
    }
  })

  .state('menu.tab.manage-channel', {
    url: '/channel/manage',
    params : {channel : null , type : null},
    views: {
      'tab-channels': {
        templateUrl: 'templates/channel-update.html',
        controller: 'ChannelUpdateCtrl'
      }
    }
  })

  .state('menu.tab.channel-detail', {
    url: '/channel/view',
    params : {channel : null},
      views: {
      'tab-channels': {
        templateUrl: 'templates/channel-detail.html',
        controller: 'ChannelDetailCtrl'
      }
    }
  })

   .state('menu.tab.channel-test', {
    url: '/channel/test',
    views: {
      'tab-channels': {
        templateUrl: 'templates/account-about.html',
        controller: 'AboutCtrl'
      }
    }

  })

  .state('menu.account-status', {
    url: '/account/status',
    views: {
      'menuContent': {
        templateUrl: 'templates/account-status.html',
        controller: 'StatusCtrl'
      }
    }
  })



  .state('menu.account-privacy', {
    url: '/account/privacy',
    views: {
      'menuContent': {
        templateUrl: 'templates/account-privacy.html',
        controller: 'PrivacyCtrl'
      }
    }
  })

  .state('menu.account-about', {
    url: '/account/about',
    views: {
      'menuContent': {
        templateUrl: 'templates/account-about.html',
        controller: 'AboutCtrl'
      }
    }
  });


  angular.forEach(['circles','events','channels','profile','activity'],function(value){
      //event detail
      //from push services
      //for the purose of event detail page to be browsable from any tab without breaking back button  
      var stateEventDetail = {
        "name" :  "menu.tab."+value+"-event-detail",
        "url": '/'+value+'/event/view',
        "cache" : false,
        "params": {
          'id' : 0,
          'data' : {}
        },
        "views": {}
      };

      stateEventDetail.views["tab-"+value] =  {
            templateUrl: 'templates/event-detail.html',
            controller: 'EventDetailCtrl'
      };
        
      $stateProvider.state(stateEventDetail);

      
      //account
      var state = {
        "name" :  "menu.tab.account-"+value,
        "url": '/'+value+'/account',
        "params" : {},
        "views": {}
      };
      state.views["tab-"+value] =  {
            templateUrl: 'templates/tab-account.html',
            controller: 'AccountCtrl'
      };
      $stateProvider.state(state);

      //moment
      var stateMoment = {
        "name" :  "menu.tab.account-moment-"+value,
        "url": '/'+value+'/moment',
        "params" : { newMoment : null },
        "views": {}
      };
      stateMoment.views["tab-"+value] =  {
            templateUrl: 'templates/tab-moments.html',
            controller: 'MomentsCtrl'
      };
      $stateProvider.state(stateMoment);


      //friend account
       var stateProfile = {
        "name" :  "menu.tab.account-friend-profile-"+value,
        "url": '/'+value+'/friend',
        "params" : {accountID : null , phone : -1},
        "views": {}
      };
      
      stateProfile.views["tab-"+value] =  {
           templateUrl: 'templates/account-friend-profile.html',
            controller: 'FriendProfileCtrl'
      };
      $stateProvider.state(stateProfile);

       //account status
       var stateAccountStatus = {
        "name" :  "menu.tab.account-status-"+value,
        "url": '/'+value+'/account/status',
        "views": {}
      };

      stateAccountStatus.views["tab-"+value] =  {
          templateUrl: 'templates/account-status.html',
          controller: 'StatusCtrl'
      };
      $stateProvider.state(stateAccountStatus);

      //account privacy
      var stateAccountPrivacy = {
        "name" :  "menu.tab.account-privacy-"+value,
        "url": '/'+value+'/account/privacy',
        "views": {}
      };

      stateAccountPrivacy.views["tab-"+value] =  {
          templateUrl: 'templates/account-privacy.html',
          controller: 'PrivacyCtrl'
      };
      $stateProvider.state(stateAccountPrivacy);

      // //account about
      // var stateAccountAbout = {
      //   "name" :  "menu.tab.account-about-"+value,
      //   "url": '/'+value+'/account/about',
      //   "views": {}
      // };

      // stateAccountAbout.views["tab-"+value] =  {
      //     templateUrl: 'templates/account-about.html',
      //     controller: 'AboutCtrl'
      // };
      // $stateProvider.state(stateAccountAbout);

      //account profile
      var stateAccountProfile = {
        "name" :  "menu.tab.account-edit-"+value,
        "url": '/'+value+'/account/edit',
        "views": {}
      };

      stateAccountProfile.views["tab-"+value] =  {
          templateUrl: 'templates/account-profile.html',
          controller: 'ProfileCtrl'
      };
      $stateProvider.state(stateAccountProfile);

      var stateAccountWeb = {
        "name" :  "menu.tab.account-web-"+value,
        "url": '/'+value+'/account/web',
        "params" : {link : null},
        "views": {}
      };

      stateAccountWeb.views["tab-"+value] =  {
          templateUrl: 'templates/account-web.html',
          controller: 'WebCtrl'
      };
      $stateProvider.state(stateAccountWeb);

      //browse photo from account page
      var statePhoto = {
        "name" :  "menu.tab.account-photo-"+value,
        "url": '/'+value+'/account/photo',
        "cache": false,
        "params" : {moment : null , account : null , access : false, extra : null},
        "views": {}
      };

      statePhoto.views["tab-"+value] =  {
          templateUrl: 'templates/social-photo-detail.html',
          controller: 'MomentPhotoCtrl'
      };
      $stateProvider.state(statePhoto);


      //browse photo from account page
      var statePhotoFriend = {
        "name" :  "menu.tab.account-friend-photo-"+value,
        "url": '/'+value+'/friend/photo',
        "cache": false,
        "params" : {moment : null , account : null},
        "views": {}
      };

      statePhotoFriend.views["tab-"+value] =  {
          templateUrl: 'templates/social-photo-detail.html',
          controller: 'MomentPhotoCtrl'
      };
      $stateProvider.state(statePhotoFriend);


       //edit own channel from account page
      var stateChannelManage = {
        "name" :  "menu.tab.account-channel-manage-"+value,
        "url": '/'+value+'/account/channel-manage',
        "params" : {channel : null , type : null},
        "views": {}
      };

      stateChannelManage.views["tab-"+value] =  {  
        templateUrl: 'templates/channel-update.html',
        controller: 'ChannelUpdateCtrl'
      };
      $stateProvider.state(stateChannelManage);
     

        //view channel detail from account page
      var stateChannelDetail = {
        "name" :  "menu.tab.account-channel-detail-"+value,
        "url": '/'+value+'/account/channel-view',
        "params" : {channel : null , type : null},
        "views": {}
      };

      stateChannelDetail.views["tab-"+value] =  {
        templateUrl: 'templates/channel-detail.html',
        controller: 'ChannelDetailCtrl'
      };
      $stateProvider.state(stateChannelDetail);

      //view channel detail from account page
      var stateChannelEventCreate = {
        "name" :  "menu.tab.account-channel-create-event-"+value,
        "url": '/'+value+'/account/event/create',
        "params" : {object : null , type : null},
        "views" : {}
      };

      stateChannelEventCreate.views["tab-"+value] =  {
        templateUrl: 'templates/event-create.html',
        controller: 'EventCreateCtrl'
      };
      $stateProvider.state(stateChannelEventCreate);

    
      // //view channel detail from account page
      var stateAccountActivity = {
        "name" :  "menu.tab.account-activities-"+value,
        "url": '/'+value+'/account/activities',
        "views" : {}
      };

      stateAccountActivity.views["tab-"+value] =  {
        templateUrl: 'templates/tab-activity.html',
        controller: 'ActivityCtrl'
      };
      $stateProvider.state(stateAccountActivity);


  });

  /* if none of the above states are matched, use this as the fallback */
  $urlRouterProvider.otherwise('/menu/tab/circles');

});

