
angular.module('gurillaApp.controllers', [])
.constant('GURILLA_URL', 'https://pro.gurilla-beta.tk/') //production server 
// .constant('GURILLA_URL', 'https://dev.gurilla-beta.tk/') // dev server 
// .constant('GURILLA_URL', 'http://localhost:8100/api/') // local server
.constant("Tutorials",{"circle" : "circle_tutorial", "circle_create":"circle_create_tutorial",
                       "profile" : "profile_tutorial",
                       "event" : "event_tutorial",
                       "channel": "channel_tutorial", "channel_create": "channel_create_tutorial", "channel_update": "channel_update_tutorial",
                       "interest": "interest_tutorial"})
.constant('MESSAGE' , { 'ERROR' : { 'OFFLINE' : "No internet connection" , "UNKNOWN" : "Unexpected error" , "SERVER_UNKNOWN" :  "Encounter server error."  }  })
/* Startup config */
.config(function($httpProvider) {
  /* Enable cross domain calls */
  $httpProvider.defaults.useXDomain = true;
  /* Remove the header used to identify ajax call that would prevent CORS from working */
  delete $httpProvider.defaults.headers.common['X-Requested-With'];
 
})
.run(['$ionicPlatform','$rootScope','$state', function ($ionicPlatform,$rootScope,$state, $timeout) {
	$ionicPlatform.ready(function(){

  	$rootScope.$on('$stateChangeSuccess', function(ev, to, toParams, from, fromParams) {
        $rootScope.prevState = from.name;
        $rootScope.prevParams = fromParams;
        $rootScope.currentState = to.name;

    });
    
    $rootScope.hideKeyboardAccessoryBar = function(boolval){
      if(window.cordova 
            && window.cordova.plugins.Keyboard){
          window.cordova.plugins.Keyboard.hideKeyboardAccessoryBar(boolval);
          window.cordova.plugins.Keyboard.disableScroll(boolval);
        
        // $cordovaKeyboard.hideAccessoryBar(boolval);
        // $cordovaKeyboard.disableScroll(boolval);
      }
    };

    $rootScope.hideKeyboardAccessoryBar(false);

    $rootScope.$on('$stateNotFound',
      function(event, unfoundState, toParams, fromState){
        
         if (unfoundState.to.indexOf('menu.tab.account') > -1) {
           event.preventDefault();
           var newState = unfoundState.to;
           if ($state.current.name.indexOf('circle') > -1) {
            newState = newState+"-circles";
           }else if($state.current.name.indexOf('event') > -1 ){
            newState = newState+"-events";
           }else if($state.current.name.indexOf('channel') > -1){
            newState = newState+"-channels";
           }else if($state.current.name.indexOf('profile') > -1){
            newState = newState+"-profile";
           }else if($state.current.name.indexOf('activity') > -1){
            newState = newState+"-activity";
           }else{

           }
           toParams.reload = true;
           $state.go(newState,unfoundState.toParams);
         }
      });
  });
}])

.controller('GurillaCtrl', function($rootScope, $scope, $state, $ionicHistory, $ionicPlatform, LocalData) {
  $rootScope.$ionicGoBack = function(backCount){
      if(LocalData.get("is_tut_showing")){
        return;  
      }
      $ionicHistory.goBack(backCount);
  };

  $ionicPlatform.registerBackButtonAction(function (event) {
      if(!LocalData.get("is_tut_showing")){
        if(LocalData.get("next_to_exit")){
          navigator.app.exitApp();    
          return;
        }

        if($state.current.name === "menu.tab.circles"){
          LocalData.set("next_to_exit");
        }
        // navigator.app.backHistory();  
        $ionicHistory.goBack();

      }
      
  }, 100);

})
.directive('compile', ['$compile', function ($compile) {
    return function(scope, element, attrs) {
        scope.$watch(
            function(scope) {
                // watch the 'compile' expression for changes
                return scope.$eval(attrs.compile);
            },
            function(value) {
                // when the 'compile' expression changes
                // assign it into the current DOM
                element.html(value);

                // compile the new DOM and link it to the current
                // scope.
                // NOTE: we only compile .childNodes so that
                // we don't get into infinite loop compiling ourselves
                $compile(element.contents())(scope);
            }
        );
    };
}])

.filter('trusted', ['$sce', function ($sce) {
    return function(url) {
        return $sce.trustAsResourceUrl(url);
    };
}])

.directive('myVdo', ['GURILLA_URL',function (GURILLA_URL) {
  return {
      restrict: 'A',
      scope : {
        video : '='
      },
      link : function(scope,elem,attr){
        var src = GURILLA_URL + 'uploads/'+scope.video;
        // if (attr.size == "org") {
        //   src = src+scope.video+'.mp4';
        // }else{
        //   src = src+attr.size+'/'+scope.video+'.mp4';
        // }

        elem.attr('src',src);
      }
    };
}])

.directive('mySrc', ['GURILLA_URL',function (GURILLA_URL) {
  return {
    restrict: 'A',
    scope : {
      photo : '='
    },
    link : function(scope,elem,attr){
      var src = GURILLA_URL + 'uploads/';
      if (attr.size == "org") {
        src = src+scope.photo+'.png';
      }else{
        src = src+attr.size+'/'+scope.photo+'.png';
      }
      	
      ImgCache.isCached(src, function(path, success) {
  		  if (success) {
  		    ImgCache.getCachedFileURL(src, function (img, newPath) {
  		 		 src = newPath;   	
  		    });

  		  }else{
    			ImgCache.cacheFile(src, function () {
    		      ImgCache.getCachedFileURL(src, function (img, newPath) {
    			 		  src = newPath;   	
    			    });
    		    });	    
    		  }
    	});
      
      elem.attr('src',src);

      }
  };
}]);