angular.module('gurillaApp.controllers')

/* @screen: View own account in details */
.controller('AccountCtrl', function(
$scope, $state, $stateParams, $http, $ionicHistory,$ionicPopover,Events,$cordovaCamera,$timeout,
$ionicModal, $ionicActionSheet, $ionicLoading, $rootScope,$ionicPopup,User,Moments,MomentCrud,SocialCrud,Helper,Circles,$window,
LocalData, Profile, GURILLA_URL, nzTour, Tutorials)
{
  $rootScope.hideTabs = false;
  $scope.account = LocalData.getAccount();
  $scope.account.country_name = Profile.getCountryName($scope.account.country);
  $scope.account.country_code = Profile.getCountryCode($scope.account.country);
  
  $scope.pushid = LocalData.get('push_id');
  $scope.gender_text = ($scope.account.gender === 0)? "Male" : ($scope.account.gender == 1)? "Female" : "Unknown";
  $scope.images = [1];
  
  Helper.showTutorial(Tutorials.profile);    


  $scope.channels = $rootScope.channels.created;

  $scope.interests = $rootScope.interests;

  
  $scope.openBrowser = function(link){
    window.open("http://"+$scope.account.website,"_blank","location=yes");
  };

  $scope.tryRefresh = function() {
    var token = LocalData.getToken();
    var account = LocalData.getAccount();
    var config = { cache: false };
    if (navigator.onLine) {
      $http.post(
        GURILLA_URL + 'users/detail',
        {
          'm': 'refresh', 'token': token
        },
        config)
      .success(function(data, status) {
        if (data.type == 'OK') {
          $scope.message = '';
          LocalData.setAccount(data.account);
          $scope.account = LocalData.getAccount();
          $scope.gender_text = ($scope.account.gender == 0)? "Male" : ($scope.account.gender == 1)? "Female" : "Unknown";
          $scope.account.country_name = Profile.getCountryName($scope.account.country);
          $scope.account.country_code = Profile.getCountryCode($scope.account.country);
        } else {
          $scope.message = data.message;
        }
      }).error(function(data, status){
        if (status == 0) {
          $scope.message = 'Unable to send data. No network connection?';
        } else {
          $scope.message = data.http_message;
          if (data.code == 403) { /* server said we are forbidden */
            LocalData.clear();
            window.location.href = 'index.html#/login';
          }
        }
      }).finally(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    } else {
      $scope.message = 'No network connection.';
      $scope.$broadcast('scroll.refreshComplete');
    }
  };

  $scope.tabCanShow = function(){
    return $state.current.name.indexOf("profile") > -1;
  };

  $scope.editProfile = function(){
    $scope.popover.hide();
    $state.go('menu.tab.account-edit');
  };

  $scope.sync = function(){
    $ionicLoading.show({
      template: '<i class="icon ion-loading-c"></i> Contacts are syncing ...'
    });

    User.sync(function(data){
      $ionicLoading.hide();
      if (data.type == "OK") {
       //store gurilla contacts seperately
       $rootScope.temp_gcontacts = data.gurilla_contacts;
      }else{
        $scope.message = data.message;
      }
    });
  };

  $scope.openAvatarActionSheet = function(){
     if(!Helper.isTutorialFinished(Tutorials.profile)){
      return;
    }
      var hideSheet = $ionicActionSheet.show({
        buttons: [
          { text: 'Use Camera' },
          { text: 'Choose Photo' }
        ],
        cancelText: 'Cancel',
        cancel: function() {
        },
        buttonClicked: function(index) {
          var source = 0;

      if (navigator.camera) {
        if (index === 0) {
          source = navigator.camera.PictureSourceType.CAMERA;
        } else if (index == 1) {
          source = navigator.camera.PictureSourceType.PHOTOLIBRARY || 0;
        } else{

        }

        navigator.camera.getPicture(

          function(imageURI) {

           var avatar = document.getElementById('gurilla-account-avatar');
           avatar.src = 'data:image/jpeg;base64,'+imageURI;
           Profile.setAvatar(imageURI, GURILLA_URL);
           
          }, function(err) {
            console.err(err);
          },
          Helper.getCameraOptions(source));
      } else {
        $rootScope.message = 'Unable to access camera. Are you on browser?';
      }

      return true;
    }
  });
  };

  $scope.goToActivity = function(){
    if(Helper.isTutorialFinished(Tutorials.profile)){
      $state.go("menu.tab.account-activities");
    }
    
  };

  $scope.goToChannels = function(){
    $state.go("menu.tab.channels");
  };

  $scope.goToInterests = function(){
    $state.go("menu.tab.interests");
  };

  $scope.createMoment = function(){
    if(!Helper.isTutorialFinished(Tutorials.profile)){
      return;
    }
    $ionicActionSheet.show({
      buttons: [
        { text: 'Use Camera' },
        { text: 'Upload Photo' },
        { text: 'Upload Video (Max 50Mb)' }
      ],
      cancelText: 'Cancel',
      cancel: function() {
      },
      buttonClicked: function(index) {
        if (navigator.camera) {
          var source = (index === 0)? navigator.camera.PictureSourceType.CAMERA : navigator.camera.PictureSourceType.PHOTOLIBRARY;
          
          var options ;
          if (index === 2) {
            options = Moments.getVdoOptions(source);
          }else{
            options =  Moments.getCameraOptions(source);
          }

          $cordovaCamera.getPicture(options).then(function(imageURI){
              if (index == 2) {
                 if(imageURI.indexOf("file://") < 0 ){
                    imageURI = "file://" + imageURI;
                 }
                
                 options = { mode: "base64", 
                            quality: .8,
                            position: 5.0, // iOS only 
                            resize: {height: 300 , width: 300}};


                 PKVideoThumbnail.createThumbnail(
                  imageURI, 
                  "IGNORE",
                   options)
                 .then(function showDataThumbnail(data) {
                    $scope.message = "";
                    $state.go("menu.tab.account-moment",{ 'newMoment' : {"image" : data, "video" : imageURI } });
                  });              


                 // navigator.createThumbnail(imageURI, function(err, imageData) {
                 //    if (!imageData) {
                 //      $scope.message = "Invalid file.";
                 //      return;
                 //    }
                 //    $scope.message = "";
                 //    $state.go("menu.tab.account-moment",{ 'newMoment' : {"image" : imageData, "video" : imageURI } });
                 //  });



              }else{
                $state.go("menu.tab.account-moment",{ 'newMoment' : {"image" : imageURI , "video" : null } });
              }
          },function(err){
                console.log(err);
          }); 
        } else {
          $scope.message = 'Unable to access camera. Are you on browser?';
        }
        return true;
      }
    });
  };

  $scope.showActions = function($event){
    if(Helper.isTutorialFinished(Tutorials.profile)){
      $scope.popover.show($event);  
    }  
  };

  $ionicPopover.fromTemplateUrl('templates/popover-account.html', {
    scope: $scope
  }).then(function(popover) {
    $scope.popover = popover;
  });

  if ($scope.account.photo) {
     var avatar = document.getElementById('gurilla-account-avatar');
     avatar.src = GURILLA_URL+"/uploads/"+$scope.account.photo+".png";
  }

  
  $scope.share = function(){
    $scope.popover.hide();
    if ($window.plugins) {
      $window.plugins.socialsharing.share('Hi guys, this is an awesome Gurilla app for all cool events... Currently its by invitation only. pls download this so we can mobilize together', null, null, 'http://goo.gl/yWSlC6');
    }
  };

  $scope.changeStatus = function(){
    if(Helper.isTutorialFinished(Tutorials.profile)){
      $state.go('menu.tab.account-status');
    }  
  };

  $scope.viewPhoto = function(moment){
    $ionicLoading.show({
      template: '<i class="icon ion-loading-c"></i> Loading...'
    });
    SocialCrud.detail(moment.social_id,function(data){
      $ionicLoading.hide(); 
      if(data.type == "OK"){
        $scope.moment = data.social;
        $state.go('menu.tab.account-photo',{"moment" : data.social, "account" : $scope.account});
      }else{
        $scope.message = data.message;
      }
    });
   
  };

  $scope.viewChannel = function(channel){
    $state.go('menu.tab.account-channel-manage',{"channel":channel,"type":"created"});
  };


  $scope.tab = 1;
  $scope.changeTab = function(tab){
    if(Helper.isTutorialFinished(Tutorials.profile)){
      $scope.tab = tab;
    }  
  };

  $scope.getPhotos = function(){
    $ionicLoading.show({
      template: '<i class="icon ion-loading-c"></i> Loading...'
    });

    MomentCrud.getUserPhotos($scope.account.id,function(data){
      $ionicLoading.hide(); 
      if(data.type == "OK"){
        $scope.moments = data.moments;
      }else{
        $scope.message = data.message;
      }
    });
  };

  $scope.getPhotos();
})

/* @screen: Logout of the app */
.controller('AccountLogoutCtrl', function($state,$ionicHistory,
$scope, $http, $ionicModal, $ionicActionSheet, $ionicLoading,MESSAGE,
LocalData, Profile, GURILLA_URL)
{

  $ionicHistory.clearHistory();

  $scope.tryLogout = function(){

    var token = LocalData.getToken();
    var config = { cache: false };

    var ehistory = LocalData.get('ehistory');
    if (ehistory) {
       ehistory = JSON.parse(LocalData.get('ehistory'));
    };

    for (var i = window.localStorage.length - 1; i >= 0; i--) {
      if( window.localStorage.key(i).indexOf("_tutorial") < 0){
          window.localStorage.removeItem(window.localStorage.key(i));
      }
    }

    window.location.href = 'index.html#/login';
   
    if(!navigator.onLine){
        return;
    }

    $ionicLoading.show({
      template: '<i class="icon ion-loading-c"></i> Logging out..'
    });

    $http.post(GURILLA_URL + 'users/logout',{ 'token': token , 'ehistory' : ehistory },config)
    .success(function(data, status) {
      
      
    }).error(function(data, status){
      console.log(data);
    }).finally(function(){
      $ionicLoading.hide();
    });


  };
  $scope.tryLogout();
})

/* @screen: Edit own profile */
.controller('ProfileCtrl', function(
$scope, $state, $stateParams, $http, $ionicHistory,
$ionicModal, $ionicActionSheet, $ionicLoading,User,LocalData, Profile, GURILLA_URL)
{
  $scope.account = LocalData.getAccount();
  // $scope.account.phone = parseInt($scope.account.phone);
  $scope.countries = Profile.country_options();
  
  var c_time = new Date();
  var c_year = c_time.getFullYear();
  $scope.years = [2016,2015,2014,2013,2012,2011,2010,2009,2008,2007,2006,2005,2004,
                 2003,2002,2001,2000,1999,1998,1997,1996,1995,1994,1993,1992,1991,1990,1989,1988,1987,
                 1986,1985,1984,1983,1982,1981,1980,1979,1978,1977,1976,1975,1974,1973,1972,1971,1970,
                 1969,1968,1967,1966,1965,1964,1963,1962,1961,1960,1959,1958,1957,1956,1955,1954,1953,1952,
                 1951,1950];
  
  $scope.tryUpdate = function(){
    
    var loading = $ionicLoading.show({
      template: '<i class="icon ion-loading-c"></i> Updating..'
    });

    $scope.account.profile = {
      'gender' : $scope.account.gender,
      'country' : $scope.account.country,
      'website' : $scope.account.website
    };

    User.update($scope.account,function(data){
      $ionicLoading.hide();
      if (data.type == "OK") {
        LocalData.setAccount(data.account);
        $state.go('menu.tab.account');
      }else{
        $scope.message = data.message;
      }
    });

  };
})

/* @screen: Edit own profile */
.controller('WebCtrl', function($scope, $state, $stateParams){
  $scope.link =   $stateParams.link ;
  if ($scope.link) {
    $scope.link = "http://" +  $scope.link ;
  };
  console.log($scope.link);
})

/* @screen: Update status */
.controller('StatusCtrl', function(
$scope, $state, $stateParams, $http, $ionicHistory,
$ionicModal, $ionicActionSheet, $ionicLoading,
LocalData, GURILLA_URL)
{
  $scope.account = LocalData.getAccount();

  $scope.setStatus = function(msg){
    $scope.account.status_message = msg;
  };

  $scope.tryUpdate= function(msg){
    var token = LocalData.getToken();
    var config = { cache: false };

    if (navigator.onLine) {
      var loading = $ionicLoading.show({
        template: '<i class="icon ion-loading-c"></i> Updating..'
      });

      $http.put(
        GURILLA_URL + 'users',
        {
          'm': 'update', 'token': token,
            'status_message': msg
        },
        config)
      .success(function(data, status) {
        if (data.type == 'OK') {
          $scope.message = '';
          LocalData.setAccount(data.account);
          $state.go('menu.tab.account');
        } else {
          $scope.message = data.message;
        }
        $ionicLoading.hide();
      }).error(function(data, status){
        if (status == 0) {
          $scope.message = 'Unable to send data. No network connection?';
        } else {
          $scope.message = data.http_message;
          if (data.code == 403) { /* server said we are forbidden */
            LocalData.clear();
            window.location.href = 'index.html#/login';
          }
        }
      }).finally(function(){
        $ionicLoading.hide();
      });
    } else {
      $scope.message = 'No network connection.';
      $ionicLoading.hide();
    }
  };
})

/* @screen: Privacy settings */
.controller('PrivacyCtrl', function(
$scope, $state, $stateParams, $http, $ionicHistory,
$ionicModal, $ionicActionSheet, $ionicLoading,
LocalData)
{
})

/* @screen: About */
.controller('AboutCtrl', function(
$scope, $state, $stateParams,$window){
  $scope.share = function(){
    if ($window.plugins) {
      $window.plugins.socialsharing.share('Hi guys, this is an awesome Gurilla app for all cool events... Currently its by invitation only. pls download this so we can mobilize together', null, null, 'http://goo.gl/yWSlC6');
    }
  };
})

/* @screen: View friend account in details */
.controller('FriendProfileCtrl', function($rootScope,
$scope, $state, $stateParams, $http, $ionicHistory,$ionicPopup,Events,EventCrud,SocialCrud,
$ionicModal, $ionicActionSheet, $ionicLoading,Channels,ChannelCrud,Interests,InterestCrud,MomentCrud,
LocalData, Profile, GURILLA_URL)
{


  $scope.openBrowser = function(){
    window.open("http://"+$scope.friend.profile.website,"_blank","location=yes");
  };

   // $scope.friend = LocalData.getAccount();
   $scope.checkSubscribedChannels = function(items){
      if (!$rootScope.channels.joined) {
        return;
      }
      for (var i = items.length - 1; i >= 0; i--) {

        for (var j = $rootScope.channels.joined.length - 1; j >= 0; j--) {
          if($rootScope.channels.joined[j].id == items[i].id){
            items[i].subscribed = true;
            break;
          }
        }
      }
      return items;
    };

    $scope.checkSubscribedInterests = function(items){
      for (var i = items.length - 1; i >= 0; i--) {
        for (var j = $rootScope.interests.length - 1; j >= 0; j--) {
          if($rootScope.interests[j].id == items[i].id){
            items[i].subscribed = true;
            break;
          }
        }
      }
      return items;
    };
    var payload = { "id" : $stateParams.accountID };
    if($stateParams.phone > 0){
      var payload = { "phone" : $stateParams.phone };
    }
    var config = {headers:  {
      "token" : LocalData.getToken()
      }
    };
    
    $scope.tryRefresh = function(){
      $ionicLoading.show({
        template: '<i class="icon ion-loading-c"></i> loading... '
      });
      $http.post(GURILLA_URL + 'users/single',payload,config).success(function(data, status) {
        if (data.type == 'OK') {
          $scope.message = '';
          $scope.friend = data.user;
          $scope.friend.my_channels = $scope.checkSubscribedChannels($scope.friend.my_channels);
          $scope.friend.my_interests = $scope.checkSubscribedInterests($scope.friend.my_interests);
          $scope.gender_text = ($scope.friend.profile.gender == "0")? "Male" : ($scope.friend.profile.gender == "1")? "Female" : "Unknown";
          $scope.friend.country_name = Profile.getCountryName($scope.friend.profile.country);
          $scope.friend.country_code = Profile.getCountryCode($scope.friend.profile.country);
          $scope.getPhotos();
        } else {
          $scope.message = data.message;
        }
      }).error(function(data, status){
        if (status == 0) {
          $scope.message = 'Unable to send data. No network connection?';
        } else {
          $scope.message = data.http_message;
          if (data.code == 403) { /* server said we are forbidden */
          
            LocalData.clear();
            window.location.href = 'index.html#/login';
          }
        }
      }).finally(function() {
        $ionicLoading.hide();
        $scope.$broadcast('scroll.refreshComplete');
      });
    };

    $scope.joinChannel = function(channel){
    
    var loading = $ionicLoading.show({
      template: '<i class="icon ion-loading-c"></i> Subscribing channel..'
    });
    
    // channel = Channels.findChannel(channel,$rootScope.channels.joined);
    ChannelCrud.detail(channel , function(data){
      if(data.type == "OK"){
          ChannelCrud.subscribe(false,data.channel,function(result){
            $ionicLoading.hide();
            if (result.type == "OK") {
             data.channel.subscribers = [{"default":""}];
             Channels.add('joined',data.channel,function(channels){
                $rootScope.channels = channels;
                channel.subscribed = true;
             });
             
            }else{
              $scope.message = data.message;
            }
          });
      }

    });
    
  };

  $scope.leaveChannel = function(channel){
    // console.log('Channel search',Channels.findChannel($scope.friend.my_channels,channel));
    var loading = $ionicLoading.show({
      template: '<i class="icon ion-loading-c"></i> Unsubscribing channel..'
    });
    //calling the exact same method for subscribing channel
    //yet with different params 
    
    ChannelCrud.subscribe(true,channel,function(data){
      if (data.type == "OK") {
       $ionicLoading.hide();
       Channels.remove('joined',$scope.index , function(channels){
        $rootScope.channels = channels;
       });
       channel.subscribed = false;
      }else{
        $scope.message = data.message;
      }
    });
  };

  $scope.subscribeInterest = function(interest){
  
    $ionicLoading.show({
      template: '<i class="icon ion-loading-c"></i> subscribing interest..'
    });
    interest.options = {
      "notification" : true,
      "age" : 0,
      "gender" : 2,
      "distance" : 0
    };
    InterestCrud.subscribe(false,interest,function(data){
      $ionicLoading.hide();
      if (data.type == "OK") {
        $rootScope.interests = Interests.add(data.interest);
        interest.subscribed = true;
      }
    });
    
  };
  
  $scope.leaveInterest = function(interest) {
     var confirmPopup = $ionicPopup.confirm({
       title: 'Unsubscribe Interest',
       template: 'Are you sure you want to unsubscribe this interest?'
     });
     confirmPopup.then(function(res) {
       if(res) {
          $rootScope.interests = Interests.remove(Interests.findInterestIndex($rootScope.interests,interest));
          InterestCrud.subscribe(true,interest,function(data){
              if (data.type == "OK") {
                $scope.message = '';
                interest.subscribed = false;
              }else{
                $scope.message = data.message;
              }
          });
       }
     });
  };

  $scope.viewChannel = function(channel){
    if (channel.subscribed) {
      $state.go('menu.tab.account-channel-detail',{"channel" : Channels.findChannel(channel,$rootScope.channels.joined)});
    }else{
      $ionicLoading.show({
        template: '<i class="icon ion-loading-c"></i> loading...'
      });
      
      ChannelCrud.detail(channel , function(data){
        $ionicLoading.hide();
        if(data.type == "OK"){
         $state.go('menu.tab.account-channel-detail',{"channel" : data.channel}); 
        }

      });
        
    }
  }; 

  $scope.tab = 1;
  $scope.changeTab = function(tab){
    $scope.tab = tab;
  };

   $scope.getPhotos = function(){
    $ionicLoading.show({
      template: '<i class="icon ion-loading-c"></i> Loading...'
    });

    MomentCrud.getUserPhotos($scope.friend.id,function(data){
      $ionicLoading.hide(); 
      if(data.type == "OK"){
        $scope.moments = data.moments;
      }else{
        $scope.message = data.message;
      }
    });
  };

  $scope.viewPhoto = function(moment){
    console.log(moment);
    $ionicLoading.show({
      template: '<i class="icon ion-loading-c"></i> Loading...'
    });
     SocialCrud.detail(moment.social_id,function(data){
      $ionicLoading.hide(); 
      if(data.type == "OK"){
        $scope.moment = data.social;
        $state.go('menu.tab.account-friend-photo',{moment : $scope.moment, account : $scope.friend});
      }else{
        $scope.message = data.message;
      }
    });

  };

  $scope.tryRefresh();
});
