angular.module('gurillaApp.services')

.factory('Activity', function(LocalData,ActivityCrud) {

  return {
    init : function(callback){
      ActivityCrud.read(function(data){
        LocalData.set('activities', JSON.stringify(data.activities));
        callback(data.activities);
      },function(data){
        console.error(data);
      });
    },
    set: function(activities){
      LocalData.set('activities',JSON.stringify(activities));
      return activities;
    },
    all: function() {
      var data = LocalData.get('activities');
  
       var activities = [];

       if (typeof data !== 'undefined') {
         activities = JSON.parse(data);
       }
       return activities;
    }
  }  
})
.factory('SocialCrud', function ($http,GURILLA_URL,LocalData,MESSAGE){
   var url = {
    "detail" : GURILLA_URL +'socials'
  };

  var config = {headers:  {
      "token" : LocalData.getToken()
    }
  };

  var getResponse = function(){
      return {"type" : "ERROR","message" : "something went wrong"};
  };

  var checkOnline = function(){
    return navigator.onLine;
  };
  return{
     detail : function(social_id,callback){
         //get fresh response object
        var response = getResponse();
        //check network status
        if(checkOnline()){
          //start calling to server
          $http.get( url.detail + '/' + social_id ,config).success(function(data, status) {
              if (status == 200) {
                 response = data;
              }
          }).error(function(data, status){
             response.message =  MESSAGE.ERROR.SERVER_UNKNOWN;
          }).finally(function(){
            callback(response);
          });
        }else{
          response.message = MESSAGE.ERROR.OFFLINE;
          callback(response);
        }  
      }
  };
})

.factory('ActivityCrud', function ($http,GURILLA_URL,LocalData,MESSAGE) {
  var url = {
    "read" : GURILLA_URL +'users/activities',
    "detail" : GURILLA_URL +'socials'
  };

  var config = {headers:  {
      "token" : LocalData.getToken()
    }
  };

  var getResponse = function(){
      return {"type" : "ERROR","message" : "something went wrong"};
  };

  var checkOnline = function(){
    return navigator.onLine;
  };

  return {
    read : function(callback){
       //get fresh response object
      var response = getResponse();
      //check network status
      if(checkOnline()){
        //start calling to server

        $http.get( url.read ,config).success(function(data, status) {
            if (status == 200) {
               response = data;
            }
        }).error(function(data, status){
           response.message =  MESSAGE.ERROR.SERVER_UNKNOWN;
        }).finally(function(){
          callback(response);
        });
      }else{
        response.message = MESSAGE.ERROR.OFFLINE;
        callback(response);
      }   
    }

  }; 
});

