angular.module('gurillaApp.services')

.factory('CalendarCrud',[function () {

 

    var checkOnline = function(){
        return navigator.onLine;
    };
    var onError = function(msg) {
        console.log('Calendar error: ' + JSON.stringify(msg));
    };
  return {
      open : function(){
       var response = "";
       if(checkOnline()){      
            if (typeof window.plugins !== 'undefined' && typeof window.plugins.calendar !== 'undefined') {
                window.plugins.calendar.openCalendar(new Date(), function(){}, onError);
            } else {
                response = 'This feature is only available for device with calendar.';
            } 
       }else{
            response = "Device is offline.";
       }
       return response;
      },
      create : function(event){
       var response = "";
       
       if(checkOnline()){
            if (typeof window.plugins !== 'undefined' && typeof window.plugins.calendar !== 'undefined') {
                  //create an event silently (on Android < 4 an interactive dialog is shown which doesn't use this options) with options:
                  var calOptions = window.plugins.calendar.getCalendarOptions(); // grab the defaults
                  calOptions.firstReminderMinutes = event.reminder; // default is 60, pass in null for no reminder (alarm)  
                  //window.plugins.calendar.createEventWithOptions(title,location,notes,startDate,endDate,calOptions,success,error);
                  var startDate = new Date(event.date);
                  var hour = parseInt(event.time.substring(0,2));
                  startDate.setHours(hour);
                  var minute = parseInt(event.time.substring(3,5));
                  startDate.setMinutes(minute);
                  startDate.setSeconds(01);
           //       alert(startDate);
                  // create event in device (local) calendar
                  window.plugins.calendar.createEventWithOptions(event.title,event.venue,event.comment,startDate,startDate,calOptions,function() {
                  },function(){
                      response = 'Unable to create event in local calendar';
                      alert('haiz');
                  });
            }else{
                response = "No calendar detected on your device."
            }
        }else{
          response = "Device is offline.";
        }
        return response;
        
      },
      update : function(oldEvent, event){
        var response = "";
        if(checkOnline()){
            //create an event silently (on Android < 4 an interactive dialog is shown which doesn't use this options) with options:
            var calOptions = window.plugins.calendar.getCalendarOptions(); // grab the defaults
            calOptions.firstReminderMinutes = event.reminder; // default is 60, pass in null for no reminder (alarm)
            var startDate = new Date(event.date);
            startDate.setHours(parseInt(event.time.substring(0,2)));
            startDate.setMinutes(parseInt(event.time.substring(3,5)));
            startDate.setSeconds(01);
            var oldStartDate = new Date(oldEvent.date);
            oldStartDate.setHours(parseInt(oldEvent.time.substring(0,2)));
            oldStartDate.setMinutes(parseInt(oldEvent.time.substring(3,5)));
            oldStartDate.setSeconds(01);
            if (typeof window.plugins !== 'undefined' && typeof window.plugins.calendar !== 'undefined') {
                // delete current version of the event
                window.plugins.calendar.deleteEvent(oldEvent.title,oldEvent.venue,oldEvent.comment,oldStartDate,oldStartDate,function(){},function(){
                    console.log('sth wrong');
                });
                // create event in device (local) calendar
                window.plugins.calendar.createEventWithOptions(event.title,event.venue,event.comment,startDate,startDate,calOptions,function() {
                },function(){
                    response = 'Unable to modify event in local calendar';
                });
            }        
        
        }else{
            response = "Device is offline.";
        }
        return response;
      
      },
      delete : function(event){
        var response = "";
        if(checkOnline()){
            var startDate = new Date(event.date);
            startDate.setHours(parseInt(event.time.substring(0,2)));
            startDate.setMinutes(parseInt(event.time.substring(3,5)));
            startDate.setSeconds(01);
            if (typeof window.plugins !== 'undefined' && typeof window.plugins.calendar !== 'undefined') {
                // delete current version of the event
                window.plugins.calendar.deleteEvent(event.title,event.venue,event.comment,startDate,startDate,function(){},function(){
                    console.log('sth wrong');
                });
            }
        }else{
            response = "Device is offline.";
        }
        return response;
      
      }
    

  };

}]);


