angular.module('gurillaApp.services')

.factory('Channels', function(LocalData,ChannelCrud) {
  return {
     init : function(callback){
      ChannelCrud.read(function(data){
         var c = { created: [], joined: [] };
          c.created = data.my_channels;
          c.joined = data.channels;
          LocalData.set('channels',JSON.stringify(c));
          callback(c);
      },function(data){
        console.error(data);
      });
    },
    set: function(channels){
      LocalData.set('channels',JSON.stringify(channels));
      return channels;
    },
    all: function() {
      var data = LocalData.get('channels');
  
       var channels = [];

       if (typeof data !== 'undefined') {
         channels = JSON.parse(data);
       }
       return channels;
    },
    //not use
    getType: function(channel) {
      var data = LocalData.get('channels');
      var channels = [];
      if (typeof data !== 'undefined') {
        channels = JSON.parse(LocalData.get('channels'));
      }

      if (typeof channels == 'undefined') {
        return undefined;
      }

      if ((typeof channels['created'] !== 'undefined') && (channels['created'])) {
        if (typeof channels['created'][channel] !== 'undefined') {
          return 'created';
        }
      }

      if ((typeof channels['joined'] !== 'undefined') && (channels['joined'])) {
        if (typeof channels['joined'][channel] !== 'undefined') {
          return 'joined';
        }
      }

      return undefined;
    },


    getChannelsByType : function(type){
      //get ls data
      var data = LocalData.get('channels');
      
      //check whether ls is empty or undefined 
      //init the channels by parsing json if pass the above condition
      var channels = [];
      if (typeof data !== 'undefined') {
        channels = JSON.parse(LocalData.get('channels'));
      }
      //before return the requested information
      //checkup whether there is any data 
      if ((typeof channels[type] !== 'undefined') && (channels[type])) {
        return channels[type];
      }
      return channels;
    },
    get: function(channel) {
      var data = LocalData.get('channels');
      var channels = [];
      if (typeof data !== 'undefined') {
        channels = JSON.parse(LocalData.get('channels'));
      }

      if (typeof channels == 'undefined') {
        return undefined;
      }

      if ((typeof channels['created'] !== 'undefined') && (channels['created'])) {
        if (typeof channels['created'][channel] !== 'undefined') {
          return channels['created'][channel];
        }
      }

      if ((typeof channels['joined'] !== 'undefined') && (channels['joined'])) {
        if (typeof channels['joined'][channel] !== 'undefined') {
          return channels['joined'][channel];
        }
      }

      return undefined;
    },
    findChannel : function(needle,haystack){
      for (var i = haystack.length - 1; i >= 0; i--) {
        if (haystack[i].id == needle.id){
          return haystack[i];
        }
      }
      return undefined;
    },

    findChannelType : function(channel){
      var data = LocalData.get('channels');
      var channels = [];
      if (typeof data !== 'undefined') {
        channels = JSON.parse(LocalData.get('channels'));
      }

      if (channels) {
        if (this.findChannel(channel,channels.created)) {
          return "created";
        }else{
          return "joined";
        }
      }

      return undefined;
    },

    //find channel by given channel id
    //the return is bind with new filed "type" => ["joined" | "created"]
    findChannelById : function(id){
      var data = LocalData.get('channels');
      var channels = [];
      if (typeof data !== 'undefined') {
        channels = JSON.parse(LocalData.get('channels'));
      }

      if (typeof channels == 'undefined') {
        return undefined;
      }

      if (channels['created']) {
        for (var i = channels.created.length - 1; i >= 0; i--) {
          if( channels.created[i].id === id ){
            return channels.created[i];
          }
        }
      }

      if ((typeof channels['joined'] !== 'undefined') && (channels['joined'])) {
        for (var i = channels.joined.length - 1; i >= 0; i--) {
          if( channels.joined[i].id === id ){
            return channels.joined[i];
          }
        }
      }
      return undefined;
    },
    findChannelIndex : function(needle,haystack){
      
      for (var i = haystack.length - 1; i >= 0; i--) {
        if (haystack[i].id == needle.id){
          return i;
        }
      }
      return -1;
    },
    update: function(type,index,channel,callback) {
      var data = LocalData.get('channels');
      var channels = [];
      if (typeof data !== 'undefined') {
        channels = JSON.parse(LocalData.get('channels'));
      }
      channels[type][index] = channel;

      LocalData.set('channels', JSON.stringify(channels));

      callback(channels);
    },
    remove: function(type,index,callback) {
      var data = LocalData.get('channels');
      var channels = [];
      
      if (typeof data !== 'undefined') {
        channels = JSON.parse(LocalData.get('channels'));
      }

      channels[type].splice(index,1);

      LocalData.set('channels', JSON.stringify(channels));

      callback(channels);
    },
    add: function(type, channel,callback) {
      //get existing localdata
      var data = LocalData.get('channels');
      var channels = [];

      //decode json object unless empty
      if (typeof data !== 'undefined') {
        channels = JSON.parse(data);
      }
      //check whether given type is exist and grt than 0
      //otherwise set blank array
      if ((channels[type] === null) || channels[type].length === 0   ) {
        channels[type] = [];
      }
      //add newly created channel
      channels[type].push(channel);
      //encode to json and store to ls
      LocalData.set('channels', JSON.stringify(channels));

      callback(channels);
    },

    isSubscribe : function(channel){
      //get existing localdata
      var data = LocalData.get('channels');
      var channels = [];
      //decode json object unless empty
      if (typeof data !== 'undefined') {
        channels = JSON.parse(LocalData.get('channels'));
      }
      //check whether given type is exist and grt than 0
      //otherwise set blank array
      return channels.joined.indexOf(channel) > -1;
    },
    getCameraOptions : function(source){
       var options = {
          quality: 70,
          sourceType: source,
          encodingType: navigator.camera.EncodingType.JPEG,
          destinationType: navigator.camera.DestinationType.DATA_URL,
          correctOrientation: true,
          targetWidth: 600,
          targetHeight : 300,
          mediaType : navigator.camera.MediaType.PICTURE,
          allowEdit: true,
          saveToPhotoAlbum: false
        };

       return options; 
    }
  };
})

.factory('ChannelCrud', ['$http','GURILLA_URL','LocalData','MESSAGE',function ($http,GURILLA_URL,LocalData,MESSAGE) {
  var url = {
    "read" : GURILLA_URL +'channels/user',
    "create" : GURILLA_URL +"channels",
    "update" : GURILLA_URL +"channels",
    "delete" : GURILLA_URL + 'channels/delete',
    "search" : GURILLA_URL +"channels/search",
    "searchall" : GURILLA_URL +"channels/searchall",
    "detail" : GURILLA_URL  + "channels",
    "subscribe" : GURILLA_URL + "users/subscribe/channel"
  };


  var getPayload = function(){
    return { "token" : LocalData.getToken() }; 
  };

  var config = {headers:  {
      "token" : LocalData.getToken()
    }
  };

  var getResponse = function(){
      return {"type" : "ERROR","message" : "something went wrong"};
  };

  var checkOnline = function(){
    return navigator.onLine;
  };

  return {
      
      read : function(callback){
        //get fresh response object
        var response = getResponse();
        //check network status
        if(checkOnline()){
          //start calling to server

          $http.post( url.read , getPayload() ,config).success(function(data, status) {
              if (status == 200) {
                 response = data;
              }
          }).error(function(data, status){
             response.message =  MESSAGE.ERROR.SERVER_UNKNOWN;
          }).finally(function(){
            callback(response);
          });
        }else{
          response.message = MESSAGE.ERROR.OFFLINE;
          callback(response);
        }  
      },

      detail : function(channel,callback){
         //get fresh response object
        var response = getResponse();
        //check network status
        if(checkOnline()){
          //start calling to server
          $http.get( url.detail + '/' + channel.id , config).success(function(data, status) {
              if (status == 200) {
                 response = data;
                 
              }
          }).error(function(data, status){
             response.message =  MESSAGE.ERROR.SERVER_UNKNOWN;
          }).finally(function(){
            callback(response);
          });
        }else{
          response.message = MESSAGE.ERROR.OFFLINE;
          callback(response);
        }  
      },

      search : function(keyword,callback){
        
         //get fresh response object
        var response = getResponse();
        //check network status
        if(checkOnline()){
          //start calling to server

          var payload = getPayload();

          payload.keyword = keyword;
          
          $http.post( url.search , payload ,config).success(function(data, status) {
              if (status == 200) {
                 response = data;
              }
          }).error(function(data, status){
             response.message =  MESSAGE.ERROR.SERVER_UNKNOWN;
          }).finally(function(){
            callback(response);
          });
        }else{
          response.message = MESSAGE.ERROR.OFFLINE;
          callback(response);
        }
      },

      searchall : function(keyword,callback){
          if (keyword == null || keyword.length === 0) {
            callback({});
          }
          //get fresh response object
          var response = getResponse();
          //check network status
          if(checkOnline()){
            //start calling to server
            $http.get( url.searchall + "/" + keyword ,config).success(function(data, status) {
                if (status == 200) {
                   response = data;
                }
            }).error(function(data, status){
               response.message =  MESSAGE.ERROR.SERVER_UNKNOWN;
            }).finally(function(){
              callback(response);
            });
          }else{
            response.message = MESSAGE.ERROR.OFFLINE;
            callback(response);
          }
      },

      create : function(channel,callback){
         //get fresh response object
        var response = getResponse();
        //check network status
        if(checkOnline()){
          //start calling to server
          var payload = getPayload();
          
          payload.name = channel.name;
          payload.photo = channel.photo;
          payload.description = channel.description;

          $http.post( url.create, payload ,config).success(function(data, status) {
              if (status == 200) {
                 response = data;
              }
          }).error(function(data, status){
             response.message =  MESSAGE.ERROR.SERVER_UNKNOWN;
          }).finally(function(){
            callback(response);
          });
        }else{
          response.message = MESSAGE.ERROR.OFFLINE;
          callback(response);
        }  
      },

      update : function(channel , callback){

         //get fresh response object
        var response = getResponse();
        //check network status
        if(checkOnline()){
          //start calling to server
          var payload = getPayload();
          payload.name = channel.name;
          payload.description = channel.description;
          payload.photo = channel.photo;


          $http.put( url.update+'/'+channel.id , payload ,config).success(function(data, status) {
            if (status == 200) {
              response.type = data.type;
              response.message = data.message;
              response.channel = data.channel;
            }
          }).error(function(data){
            response.message =  MESSAGE.ERROR.SERVER_UNKNOWN;
          }).finally(function(){
            callback(response);
          });
        }else{
          response.message = MESSAGE.ERROR.OFFLINE;
          callback(response);
        }  

      },

      subscribe : function(unsubscribe,channel,callback){
        
        //get fresh response object
        var response = getResponse();
        //check network status
        if(checkOnline()){
          var payload = getPayload();
          
          if ( unsubscribe ){
            payload.unsubscribe = true;
          }

          payload.channel_id = channel.id;

          //start calling to server
          $http.post( url.subscribe , payload ,config).success(function(data, status) {
              if (status == 200) {
                 response = data;
              }
          }).error(function(data, status){
             response.message =  MESSAGE.ERROR.SERVER_UNKNOWN;
          }).finally(function(){
            callback(response);
          });
        }else{
          response.message = MESSAGE.ERROR.OFFLINE;
          callback(response);
        }
      },

      delete : function(id,callback){
         //get fresh response object
        var response = getResponse();
        //check network status
        if(checkOnline()){
          //start calling to server

          $http.post( url.delete+'/'+id , getPayload() ,config).success(function(data, status) {
              if (status == 200) {
                response.type = data.type;
                response.message = data.message;
              }
          }).error(function(data){
            response.message =  MESSAGE.ERROR.SERVER_UNKNOWN;
          }).finally(function(){
            callback(response);
          }); 
        }else{
          response.message = MESSAGE.ERROR.OFFLINE;
          callback(response);
        }  
      }
  };

}]);

