angular.module('gurillaApp.controllers')
/* @screen: List of circles */

.controller('CirclesCtrl', function(
$rootScope, $scope, $state, $stateParams, $http, $ionicHistory,$ionicListDelegate,$cacheFactory,
$ionicLoading, $ionicModal, $ionicPopup,$timeout,CircleCrud,User,Helper,Tutorials,
LocalData, Profile, Circles, Contacts, GURILLA_URL, nzTour, moment)
{
  $rootScope.hideTabs = false;
  $rootScope.isSyncContacts = false;

  $timeout(function() {
    if (!LocalData.get('newsignup') && !LocalData.get(Tutorials.circle)){
      Helper.showTutorial(Tutorials.circle);
    }
  }, 1000);

  $scope.getTime = function(obj){
    return Helper.getDate(obj.created_at);
  };
  
  //update profile on new signup 
  $scope.updateProfile = function(){
     
    // $ionicLoading.show({
    //   template: '<i class="icon ion-loading-c"></i> Updating..'
    // });

    $scope.account.profile = {
      'gender' : $scope.account.gender,
      'phone': $scope.account.phone,
      'country' : $scope.account.country
    };

    User.update($scope.account,function(data){
      $ionicLoading.hide();
      if (data.type == "OK") {
        LocalData.setAccount(data.account);
        $rootScope.temp_gcontacts = Circles.initGurillaContacts(data.account.contacts);
        // LocalData.remove('newsignup');
        $scope.modal.hide();
        $state.go('menu.account');
      }else{
        $scope.message = data.message;
      }
    });
  };

  /* Reading circles */
  $scope.search = { keyword: ''};

  $scope.$watch("search.keyword", function(newValue, oldValue) {
    if (newValue && newValue.trim() != '') {
      newValue = newValue.trim();
      oldValue = oldValue.trim();
      if (newValue != oldValue) {
        delete $scope.suggestions;
        var token = LocalData.getToken();
        var config = { cache: false };
        if (navigator.onLine) {
          $scope.showLoading = true;
          $http.post(
            GURILLA_URL + 'users/search',{'token': token,'keyword': newValue},config).success(function(data, status) {
            if (data.type == 'OK') {
              $scope.message = '';
              $scope.showLoading = false;
              $scope.suggestions = data.users;
              
              if (Object.keys($scope.suggestions).length == 0) {
                $scope.noSuggestion = true;
              } else {
                $scope.noSuggestion = false;
              }
            } else {
              $scope.message = data.message;
            }
          }).error(function(data, status){
            if (status == 0) {
              $scope.message = 'Unable to send data. No network connection?';
            } else {
              $scope.message = data.http_message;
              if (data.code == 403) { /* server said we are forbidden */
                LocalData.clear();
                window.location.href = 'index.html#/login';
              }
            }
          }).finally(function() {
            $ionicLoading.hide();
            $scope.$broadcast('scroll.refreshComplete');
          });
        } else {
          $scope.message = 'No network connection.';
          $ionicLoading.hide();
          $scope.$broadcast('scroll.refreshComplete');
        }
      }
    }
  });

  $scope.showSearch = function(){
    if(Helper.isTutorialFinished(Tutorials.circle)){
      $scope.searchModal.show();
    }
  };

  $scope.showProfile = function(account) {
      $scope.searchModal.hide();
      $state.go("menu.tab.account-friend-profile",{accountID : account.id});  
  };

  $scope.createCircle = function(){
    if(Helper.isTutorialFinished(Tutorials.circle)){
      $state.go('menu.tab.circle-create');
    }
  };

  $scope.viewProfile = function(){
    if(Helper.isTutorialFinished(Tutorials.circle)){
      $state.go("menu.tab.account");
    }  
  };

  //fetch the list of circles from server
  //put the result into golbal circles var
  $scope.tryRefresh = function(){
    CircleCrud.read(function(data){

      $scope.$broadcast('scroll.refreshComplete');
      $ionicLoading.hide();
      if (data.type == "OK") {
        $scope.message = '';
        $rootScope.circles = Circles.set(data.my_circles);
        $rootScope.temp_gcontacts = Circles.initGurillaContacts();
      }else{
        $scope.message = data.message;
      }

    });

    $scope.syncContacts();
  };


  //redirect to edit screen
  $scope.editCircle = function(circle){
    $state.go("menu.tab.circle-edit",{"circle" : circle});
  };
  //create new event
  $scope.createNewEvent = function(circle) {
    $ionicListDelegate.closeOptionButtons();
    $state.go('menu.tab.circle-create-event', {"type":"circles" , "object" : circle});
  };

  $scope.syncContacts = function(){
            console.log("Contacts will be sync");
    User.sync(function(data){
      
      $rootScope.isSyncContacts = true;
      if (data.type == "OK") {
       //store gurilla contacts seperately
       $rootScope.temp_gcontacts = data.gurilla_contacts;
       $rootScope.isSyncContacts = false;

      }else{
        $scope.message = data.message;
      }
    });
  };
  
  //check whether need to refresh or not
  if ($rootScope.circles === undefined) {
    $rootScope.circles = Circles.all();
   
    
  if ($rootScope.circles === undefined) {
      $ionicLoading.show({
        template: '<i class="icon ion-loading-c"></i> loading circles ...'
      });

      $timeout(function(){
        $scope.tryRefresh();  
      }, 1000);
    
      
    }
  }

  $scope.account = LocalData.getAccount();

  // /* If this is a new signup (redirected from signup page), then prompt to update profile first */
  if (typeof LocalData.get('newsignup') !== 'undefined') {

    var alertPopup = $ionicPopup.alert({
       title: 'Email verification',
       template: 'Verification link has been sent to your email!'
     });

    alertPopup.then(function(res) { 
      //remove all tutorial data if the user is new created  
        if (LocalData.get('newsignup')) {
          for (var i = window.localStorage.length - 1; i >= 0; i--) {
            if( window.localStorage.key(i).indexOf("_tutorial") > 0){
                window.localStorage.removeItem(window.localStorage.key(i));
            }
          }
        }

        Helper.showTutorial(Tutorials.circle);
        $scope.syncContacts();
   });  
  }

  //Circle search modal template
  $ionicModal.fromTemplateUrl('templates/modal-search-friends.html', function($ionicModal) {
    $scope.searchModal = $ionicModal;
  }, {
    scope: $scope,
    focusFirstInput: true,
    animation: 'slide-in-up'
  });
  
  //Listen for the event for loading
  $rootScope.$on('finish loading',function(event){
    $ionicLoading.hide();
  });

})

/* @screen: Edit a circle */
.controller('CircleEditCtrl', function(
$rootScope, $scope, $state, $stateParams,$ionicHistory,User,
$ionicModal, $ionicLoading, $ionicPopup,CircleCrud,$cordovaCamera,$ionicActionSheet,
LocalData, Circles, Contacts, GURILLA_URL)
{
  $rootScope.hideTabs = false;
  $scope.showDelete = false;
  $scope.contacts = [];
  //circle
  $scope.circle = {};
  
  //init index for later use
  var cindex = null;
  //retrieve circle param and init to $scope.circle
  if ($stateParams.circle !== null) {
    // fetch the index of given circle
    cindex = $rootScope.circles.indexOf($stateParams.circle);
    // init $scope.circle
    $scope.circle = angular.copy($rootScope.circles[cindex]);
    $scope.oldCircle = angular.copy($rootScope.circles[cindex]);
  }

  
  //init data for search 
  $scope.data = {};
  //clear search keyword
  $scope.clearSearch = function() {
    $scope.data.searchQuery = '';
  };

  $scope.isGurillaUser = function(contact){
    return User.isGurillaUser(contact);
  };

   $scope.openCameraActionSheet = function(){
    var hideSheet = $ionicActionSheet.show({
      buttons: [
        { text: 'Use Camera' },
        { text: 'Choose Photo' }
      ],
      cancelText: 'Cancel',
      cancel: function() {
      },
      buttonClicked: function(index) {
        if (navigator.camera) {
          
          var source = (index == 1)? navigator.camera.PictureSourceType.PHOTOLIBRARY : navigator.camera.PictureSourceType.CAMERA;

          $cordovaCamera.getPicture(Circles.getCameraOptions(source)).then(function(imageURI) {
              //set blank to existing photo
              $scope.circle.photo = '';
              //add new photo
              $scope.circle.newPhoto = imageURI;

              var coverPhoto = document.getElementById('coverPhoto');
              coverPhoto.src = 'data:image/jpeg;base64,'+imageURI;
          }, function(err) {
            console.error(err);
          });

        } else {
          $scope.message = 'Unable to access camera. Are you on browser?';
        }
        return true;
      }
    });
  };

  $scope.showProfile = function(contact) {
    var phoneNumber = User.getGurillaUserPhone(contact);
    if (phoneNumber) {
      if (Contacts.isMeWithPhone(phoneNumber)) {
         $state.go("menu.tab.account");
      }else{
          $state.go("menu.tab.account-friend-profile",{phone : phoneNumber});
      }

    }else{
      var alertPopup = $ionicPopup.alert({
         title: 'Gurilla',
         template: 'User is not a greenie!'
       });
    }
  };
  //show the contacts
  //put {check : true} in each contact 
  //if there are previously chose
  $scope.showContacts = function() {

    $scope.gcontacts = Contacts.getAll();
  //   $scope.gcontacts = angular.fromJson($scope.gcontacts);
    
    //check for previous selected contacts
    $scope.gcontacts = Contacts.lookCheckKey($scope.gcontacts,$scope.circle.contacts);
    $scope.modal.show();
  };

  //retrieve those of circles which are checked 
  //by user and put them into current scope circle contacts
  $scope.updateContacts = function() {
    //init temp array
    var working = [];
    //detect check key and put it into working array
    for (var i = 0, len = $scope.gcontacts.length; i < len; i++) {
      if ($scope.gcontacts[i].checked === true) {
        working.push($scope.gcontacts[i]);
      }
    }
    //update the scope.circle contacts to working array
    $scope.circle.contacts = working;
    $scope.modal.hide();
  };
  
  //show dialog for confimation before remove
  //then delete
  $scope.removeCircle = function() {
     var confirmPopup = $ionicPopup.confirm({
       title: 'Delete Circle',
       template: 'You are about to delete the circle ?'
     });
     //delete circle if user click okay
     confirmPopup.then(function(res) {
        if (res) {
            $state.go('menu.tab.circles');
            $rootScope.circles = Circles.remove(cindex);
            
            CircleCrud.delete($scope.circle.id,function(data){
              if (data.type == "OK") {
                $scope.message = '';
              }else{
                $scope.message = data.message;
              }
          });

        }

     });
  };

  //remove given contact
  $scope.removeContact = function(contact) {
    $scope.circle.contacts.splice($scope.circle.contacts.indexOf(contact),1);
  };

  $scope.tryUpdate = function() {
    
    var loading = $ionicLoading.show({
      template: '<i class="icon ion-loading-c"></i> Updating circle..'
    });

    CircleCrud.update($scope.circle,function(data){
      $ionicLoading.hide();
      if (data.type == "OK") {
        $scope.message = '';
        $rootScope.circles = Circles.update(cindex,data.circle);
        $state.go('menu.tab.circles');    
        
      }else{
        $scope.message = data.message;
      }
    });

  };

  $scope.createNewEvent = function(circle) {
    if($scope.circle.contacts && $scope.circle.contacts.length === 0){
      $ionicPopup.alert({
       title: 'Circle',
       template: 'Circle doesn\'t seem to have any contacts. Add one or more contacts to mobilize!'
     });
      return;
    }

    if( JSON.stringify($scope.circle) !=  JSON.stringify($scope.oldCircle) ){
      CircleCrud.update($scope.circle,function(data){
          if (data.type == "OK") {
            $scope.message = '';
            $rootScope.circles = Circles.update(cindex,data.circle);
          }else{
            $scope.message = data.message;
          }
      });
    }
    $state.go("menu.tab.circle-create-event",{"type":"circles" , "object" : $scope.circle});
  };

  $ionicModal.fromTemplateUrl('templates/modal-circle-contacts.html', function($ionicModal) {
      $scope.modal = $ionicModal;
  }, {
      scope: $scope,
      focusFirstInput: true,
      animation: 'slide-in-up'
  });
})

/* @screen: Create new circle */
.controller('CircleCreateCtrl', function($rootScope, $scope, $state, $ionicHistory,$cordovaCamera,$timeout, User,
  $ionicModal, $ionicLoading,CircleCrud,$ionicActionSheet,LocalData, Circles, Contacts, nzTour, Helper, Tutorials)
{
  $rootScope.hideTabs = false;
  $scope.showDelete = false;
  //create blank circle with contacts  

  Helper.showTutorial(Tutorials.circle_create);

  $scope.newCircle = {
    contacts : []
  };

  $scope.data = {};
  //search keyword
  $scope.clearSearch = function() {
    $scope.data.searchQuery = '';

  };

  $scope.openCameraActionSheet = function(){
    if(Helper.isTutorialFinished(Tutorials.circle_create)){
        var hideSheet = $ionicActionSheet.show({
          buttons: [
            { text: 'Use Camera' },
            { text: 'Choose Photo' }
          ],
          cancelText: 'Cancel',
          cancel: function() {
          },
          buttonClicked: function(index) {
            if (navigator.camera) {
              
              var source = (index == 1)? navigator.camera.PictureSourceType.PHOTOLIBRARY : navigator.camera.PictureSourceType.CAMERA;

              $cordovaCamera.getPicture(Circles.getCameraOptions(source)).then(function(imageURI) {
                 var coverPhoto = document.getElementById('coverPhoto');
                  $scope.newCircle.photo = imageURI;
                  coverPhoto.src = 'data:image/jpeg;base64,'+imageURI;          
              }, function(err) {
                console.error(err);
              });

            } else {
              $scope.message = 'Unable to access camera. Are you on browser?';
            }
            return true;
          }
        });  
    }
  };

  $scope.isGurillaUser = function(contact){
    return User.isGurillaUser(contact);
  };


  $scope.showContacts = function() {
    //fetch the fresh contacts from local db
    if(Helper.isTutorialFinished(Tutorials.circle_create)){
      $scope.gcontacts = Contacts.getAll();
      // $scope.gcontacts = Contacts.lookCheckKey($scope.gcontacts, $scope.newCircle.contacts);
      $scope.modal.show();
    }
  };

  $scope.updateContacts = function() {
    var working = [];
    for (var i = 0, len = $scope.gcontacts.length; i < len; i++) {
      if ($scope.gcontacts[i].checked === true) {
        working.push($scope.gcontacts[i]);
      }
    }
    $scope.newCircle.contacts = working;
    $scope.modal.hide();
  };

  $scope.removeContact = function(contact) {
    $scope.newCircle.contacts.splice($scope.newCircle.contacts.indexOf(contact),1);
  };

  $scope.tryCreate = function(){
    $ionicLoading.show({
      template: '<i class="icon ion-loading-c"></i> Adding circle..'
    });

    CircleCrud.create($scope.newCircle,function(data){
      $ionicLoading.hide();
      
      if (data.type == "OK") {
        $state.go('menu.tab.circles');
        $scope.message = '';
        $rootScope.circles = Circles.add(data.circle);
        $scope.newCircle = '';
      }else{
        $scope.message = data.message;
      }
    });
  };

  $ionicModal.fromTemplateUrl('templates/modal-circle-contacts.html', function($ionicModal) {
      $scope.modal = $ionicModal;
  }, {
      scope: $scope,
      focusFirstInput: true,
      animation: 'slide-in-up'
  });

});
