angular.module('gurillaApp.services')

.factory('Helper', function (GURILLA_URL,$http,LocalData,nzTour,Tutorials,$timeout) {
  
  var appTour = window.appTour = {
            config: {
                mask: {
                    visible: true, // Shows the element mask
                    visibleOnNoTarget: false, // Shows a full page mask if no target element has been specified
                    clickThrough: false, // Allows the user to interact with elements beneath the mask
                    clickExit: false, // Exit the tour when the user clicks on the mask
                    scrollThrough: true, // Allows the user to scroll the scrollbox or window through the mask
                    color: 'rgba(0,0,0,.7)' // The mask color
                },
                scrollBox: 'body', // The container to scroll when searching for elements
                previousText: 'Previous',
                nextText: 'Next',
                finishText: 'Finish',
                showPrevious: true, // Setting to false hides the previous button
                showNext: true, // Setting to false hides the next button
                animationDuration: 400, // Animation Duration for the box and mask
                dark: false, // Dark mode (Works great with `mask.visible = false`)
                disableInteraction: false, // Disable interaction with the highlighted elements
                highlightMargin: 0, // Margin of the highglighted area
                disableEscExit: false, // Disable end of tour when pressing ESC,
                onClose: function() {}, //Function called when the tour is closed
                onComplete: function() {} //Function called when the tour is completed
            },
            steps: []
        };




  var tuts = {};

  tuts[Tutorials.circle] = [{  target: '#add_circle',
                      content: "Click here to create new circle!" 
                    },{
                      target: '#profile',
                      content: "Click here to view your profile!"
                    },{
                      target: '#search_friend',
                      content: "Click here to search and see what other people do in Gurilla!" 
                    }];
  tuts[Tutorials.circle_create] = [{
                          target: '#tut_circle_name',
                          content: "Give your circle a name! (Eg Family, Collegues,... ) "
                        },{
                           target: '#tut_circle_contacts',
                           content: "Click \"+\" to select friends in your phone contacts!" 
                        },{
                           target: '#coverPhoto',
                           content: "You can also add nice cover photo for your circle!" 
                        },{
                          target : "#tut_circle_done",
                          content: "Click here to save your circle!"
                        }]; 
  tuts[Tutorials.profile] = [{
                  target: '#gurilla-account-avatar',
                  content: "Add or change your profile image here!"
              },{
                 target: '#tut_profile_status',
                 content: "Customise your realtime status here!" 
              },{
                 target: '#tut_profile_create_moment',
                 content: "Create your moment and share with others!" 
              },{
                target : "#tut_profile_activity",
                content: "Check here for activities such as who doped, commented on your moments and mentioned you!"
              },{
                target : "#tut_profile_setting",
                content: "Click for more options!"
              },{
                target : "#tut_profile_tabs",
                content: "Quick show of your created channels & your interests!"
              }];

   tuts[Tutorials.channel] = [{
              target: '#tut_channel_create',
              content: 'Click "+" button to create new channel!'
          },{
             target: '#tut_channel_search',
             content: "Click here to search for all public channels!" 
          }];


   tuts[Tutorials.channel_create] = [{
                  target: '#tut_channel_detail',
                  content: 'Provide data and click create to add channel!'
              },{
                 target: '#tut_channel_cover',
                 content: "Add cover photo here!" 
              }];


   tuts[Tutorials.channel_update] = [{
              target: '#tut_channel_comments',
              content: 'Click here to see who are participating and discussing about your channel!'
          },{
             target: '#tut_channel_subscribers',
             content: "See how many people find your channel interesting and subscribed!" 
          },{
             target: '#tut_channel_more',
             content: "Click here to see other options!" 
          }];

    tuts[Tutorials.interest] = [{
              target: '#tut_interest_add',
              content: 'Click here to add interest!'
          },{
             target: '#tut_interest_general',
             content: "Tap to set general setting for all interests!" 
          }];
    
    tuts[Tutorials.event] = [{
              target: '#tut_event_create',
              content: 'Click "+" button to create new event!'
          },{
             target: '#tut_event_tabs',
             content: "Change tabs to see latest event status!" 
          },{
             target: '#tut_event_calender',
             content: "View events schedue in system calendar!" 
          }];



  getTour = function(){
    return appTour;
  };
  
  return {
    getDate : function(UTCTime){
      var createdAt = UTCTime + " Z";
      return moment(createdAt).format("DD MMM YYYY");
    },

    getTime : function(UTCTime){
      var createdAt = UTCTime + " Z";
      return moment(createdAt).format("DD MMM YYYY, h:mm a");
    },

    isTutorialFinished : function(module){
      return LocalData.get(module) == "true";
    },

    showTutorial: function(module){

        if(LocalData.get(module) == "true"){
          return;
        }

        LocalData.set("is_tut_showing","true");
        $timeout(function() {
          var appTour = getTour();
          appTour.steps = tuts[module];
          nzTour.start(appTour).then(function() {
              LocalData.remove('newsignup');
              LocalData.remove('is_tut_showing');
              LocalData.set(module,"true");
          }).catch(function() {
              LocalData.remove('newsignup');
              LocalData.remove('is_tut_showing');
              LocalData.set(module,"true");  
          });
        }, 500);
        
    },

    getCameraOptions : function(source){
      var options = {
          quality: 70,
          sourceType: source,
          encodingType: navigator.camera.EncodingType.JPEG,
          destinationType: navigator.camera.DestinationType.DATA_URL,
          correctOrientation: true,
          targetWidth: 200,
          targetHeight : 200,
          mediaType : navigator.camera.MediaType.PICTURE,
          allowEdit: true,
          saveToPhotoAlbum: false
        };

      return options; 
    }
  };
});
