angular.module('gurillaApp.controllers')

/* @screen: List of interests/activities */
.controller('InterestsCtrl', function(
$rootScope, $scope, $state, $stateParams, $http, $ionicHistory,User,
$ionicModal, $ionicLoading, $ionicPopup,InterestCrud,LocalData, Interests, $ionicActionSheet, GURILLA_URL ,$timeout,nzTour,Helper,Tutorials)
{
  $rootScope.hideTabs = false;
  $scope.message = '';
  $scope.newInterest = false;
  $scope.general = false;
  var index = -1;


  Helper.showTutorial(Tutorials.interest);
 
  $scope.hours = {
    "00": "12am", "01": "1am", "02": "2am", "03": "3am",
    "04": "4am", "05": "5am", "06": "6am", "07": "7am",
    "08": "8am", "09": "9am", "10": "10am", "11": "11am",
    "12": "12pm", "13": "1pm", "14": "2pm", "15": "3pm",
    "16": "4pm", "17": "5pm", "18": "6pm", "19": "7pm",
    "20": "8pm", "21": "9pm", "22": "10pm", "23": "11pm",
  };
  
  $scope.searchInterests = function(){
    if(!Helper.isTutorialFinished(Tutorials.interest)){
      return;
    }
    $scope.searchKeyWord = '';
    $scope.suggestions = [];
    $scope.modalSearch.show();
  };

  $scope.distances = [
    {id : "-1", label : "All"},
    {id : "0", label : "Singapore"},
    {id : "1", label : "1km"},
    {id : "5", label : "5km"},
    {id : "10", label : "10km"},
    {id : "20", label : "20km"},
    {id : "30", label : "30km"},
    {id : "40", label : "40km"}
  ];
  $scope.selectedValue = $scope.distances[0].id;

  //set var for timer
  var timer;
  //call this function whenever user stop typing
  //http method will call after 0.5 sec
  $scope.search = function(k){
    
     $timeout.cancel(timer);
     $scope.suggestions = [];
     timer = $timeout(function(){
        $scope.searchKeyWord = $scope.searchKeyWord.trim();
        k = k.trim();
        if ($scope.searchKeyWord != k && k.length > 0 ) {
          $scope.showLoading = true;
          $scope.searchKeyWord = k;
          InterestCrud.search($scope.searchKeyWord,function(data){
            if (data.type == "OK") {
              $scope.showLoading = false;
              $scope.suggestions = (data.interests.length > 0)? data.interests : [{ "name" : $scope.searchKeyWord }] ;
            }else{
              $scope.message = data.message;  
            }
          });
        }
     }, 500);
  };

  $scope.showSetting = function(interest){
    
    if(!Helper.isTutorialFinished(Tutorials.interest)){
      return;
    }
    $scope.country = LocalData.get('country');
    if (interest == '') {
      $scope.general = true;
      $scope.interest = {};
      $scope.interest.options = LocalData.get('generalSetting');
      if (!$scope.interest.options || $scope.interest.options === "{}") {
        $scope.interest.options = {
          "notification" : true,
          "age" : 0,
          "gender" : 2,
          "distance" : -1
        };
      }else{
        $scope.interest.options = JSON.parse($scope.interest.options);  
      }
      
    }else{
      index = $rootScope.interests.indexOf(interest);
      $scope.interest = angular.copy(interest);
    }
    $scope.modalSettings.show();
  };



  $scope.hideSetting = function() {
    index = -1;
    $scope.modalSettings.hide();
    $timeout(function(){
      if ($scope.general) {
        $scope.general = false;
      }
    },500);
  };

  $scope.selectDistance = function(){
    console.log($scope.selectedValue);
  };
  
  //fetch the list of interests from server
  //put the result into golbal interests var
  $scope.tryRefresh = function(){
    InterestCrud.read(function(data){

      $scope.$broadcast('scroll.refreshComplete');
      
      if (data.type == "OK") {
        $scope.message = '';
        $rootScope.interests = Interests.set(data.interests);
        
      }else{
        $scope.message = data.message;
      }

    });
  };

  $scope.addInterest = function(interest){

    $scope.newInterest = true;

    for (var i = $rootScope.interests.length - 1; i >= 0; i--) {
      if($rootScope.interests[i].name.toLowerCase() === interest.name.toLowerCase()){
         var alertPopup = $ionicPopup.alert({
           title: 'Interest',
           template: 'Interest is already added.'
         });
         return false;
      }
    };

    $scope.interest = interest;

    $scope.interest.options = {
      "notification" : true,
      "age" : 0,
      "gender" : 2,
      "distance" : -1
    };
    
    $scope.doneAdding();
  };

  $scope.doneAdding = function() {

    if ($scope.interest.id === undefined ) {
      loading = $ionicLoading.show({
        template: '<i class="icon ion-loading-c"></i> Adding interest..'
      });

      InterestCrud.create($scope.interest,function(data){
        $ionicLoading.hide();
        if (data.type == "OK") {
          $scope.interest = '';
          $scope.newInterest = false;
          $rootScope.interests = Interests.add(data.interest);
        }
      });
    }else{
      loading = $ionicLoading.show({
        template: '<i class="icon ion-loading-c"></i> subscribing interest..'
      });

      InterestCrud.subscribe(false,$scope.interest,function(data){
        $ionicLoading.hide();
        if (data.type == "OK") {
          $scope.interest = '';
          $scope.newInterest = false;
          $rootScope.interests = Interests.add(data.interest);
        }
      });
    }
    $scope.hideSetting();
  };

  $scope.updateInterest = function(){

    $rootScope.interests = Interests.update(index,$scope.interest);

    InterestCrud.update($scope.interest,function(data){
      if (data.type == "OK") {}
    });

    $scope.hideSetting();
  };

  $scope.updateGeneralSetting = function(){
    if(!Helper.isTutorialFinished(Tutorials.interest)){
      return;
    }
    if($rootScope.interests.length == 0){
      var alertPopup = $ionicPopup.alert({
           title: 'Interest',
           template: 'Seems that you don\'t have any interest yet!'
         });
      return false;
    }

    InterestCrud.update($scope.interest,function(data){
      console.log(data);
    });

    for (var i = 0; i < $rootScope.interests.length; i++) {
      $rootScope.interests[i].options = $scope.interest.options;
      LocalData.setObject('generalSetting', $scope.interest.options);
      Interests.update(i,$rootScope.interests[i]);
      InterestCrud.update($rootScope.interests[i],function(data){
        if (data.type == "OK") {}
      });
    }
    $scope.general = false;
    $scope.hideSetting();
  };


  $scope.unsubscribe = function() {
     var confirmPopup = $ionicPopup.confirm({
       title: 'Unsubscribe Interest',
       template: 'Are you sure you want to unsubscribe this interest?'
     });
     confirmPopup.then(function(res) {
       if(res) {
          $rootScope.interests = Interests.remove(index);
          InterestCrud.subscribe(true,$scope.interest,function(data){
              if (data.type == "OK") {
                $scope.message = '';
              }else{
                $scope.message = data.message;
              }
          });
          $scope.hideSetting();
       }
     });
  };

   /* Search interests modal */
  $ionicModal.fromTemplateUrl('templates/modal-search-interests.html', function($ionicModal) {
      $scope.modalSearch = $ionicModal;
  }, {
      scope: $scope,
      focusFirstInput: true,
      animation: 'slide-in-up'
  });

  /* Interest settings modal */
  $ionicModal.fromTemplateUrl('templates/modal-interest-settings.html', function($ionicModal) {
      $scope.modalSettings = $ionicModal;
  }, {
      scope: $scope,
      focusFirstInput: true,
      animation: 'slide-in-up'
  });

  if (typeof $scope.interests === 'undefined') {
    $rootScope.interests = Interests.all();
    if (typeof  $rootScope.interests === 'undefined') {
      var loading = $ionicLoading.show({
        template: '<i class="icon ion-loading-c"></i> Loading interests..'
      });
      $scope.tryRefresh();
    }
  }


});
