angular.module('gurillaApp.services')

.factory('LocalData', ['$window', function($window) {
  return {
    getUserID : function(){
      account = JSON.parse($window.localStorage.getItem('account'));
      return account.id;
    },
    clear: function() {
      return $window.localStorage.clear();
    },
    remove: function(key) {
      return $window.localStorage.removeItem(key);
    },
    set: function(key, value) {
      if (typeof value == 'undefined') {
        $window.localStorage.removeItem(key);
        return true;
      }else if (typeof value == 'object') {
        $window.localStorage[key] = JSON.stringify(value);
        return true;
      }else{
        $window.localStorage[key] = value;
        return true;
      }
      return false;
    },
    setString: function(key, string) {
      $window.localStorage[key] = string;
      return true;
    },
    setObject: function(key, object) {
      $window.localStorage.removeItem(key);
      $window.localStorage[key] = JSON.stringify(object);
      return true;
    },
    loadKeyFromSharePref : function(key,callback){
      $window.sharedpreferences.getString(key, function(data){
          if (arguments[0]) {
            callback(arguments[0]);
          }
      }, function(error){
          callback(false);
      });
    },
    saveKeyToSharePref : function(key,value,callback){
       $window.sharedpreferences.putString(key,value, function(data){
          callback(true);
      }, function(error){
        console.log(false);
      });
    },
    initSharePref : function(callback){
      $window.sharedpreferences.getSharedPreferences("gurilla", "MODE_APPEND", function(success){
          callback(true);
        },function(error){
          console.log('Can not access SP info');
        });
    },

    get: function(key) {
      return $window.localStorage[key];
    },
    getObject: function(key) {
      if(typeof $window.localStorage[key] !== 'undefined'){
        return JSON.parse($window.localStorage[key]);
      }else{
        return undefined;
      }
    },
    getToken: function() {
      return $window.localStorage['token'];
    },
    getAccount: function() {
      if (typeof $window.localStorage['account'] != 'undefined') {
        return JSON.parse($window.localStorage['account']);
      } else {
        return undefined;
      }
    },
    setAccount: function(object) {
      $window.localStorage['account'] = JSON.stringify(object);
      return true;
    },
    forceReadObject : function(key){
      var data = $window.localStorage[key];
      if(data === undefined){
        $window.localStorage[key] = "{}";
        data = "{}";
      }
      return JSON.parse(data);
    }
  };
}])

;
