angular.module('gurillaApp.controllers')
/* @screen: List of circles */
.controller('MomentsCtrl', function($cordovaCamera, $timeout,$compile,$stateParams,$cordovaFileTransfer,LocalData,GURILLA_URL,
$rootScope, $scope, $state,$ionicLoading, $ionicModal, $ionicPopup , $ionicActionSheet , MomentCrud , Moments , Circles , User , ChannelCrud )
{
    $rootScope.message = '';
    $scope.search = { keyword: ''};

    $scope.showLoading = false;
    // //new event 

    $scope.percent = 0;

    $scope.newMoment = {
      id : 0,
      description : "",
      channels : [] , 
      mentions : [],
      image : $stateParams.newMoment.image,
      video : $stateParams.newMoment.video
    };

    console.log($scope.newMoment);

    var addSignPos = hashPos = -1;
    $scope.$watch('newMoment.description', function(newValue, oldValue) {
      $scope.search.keyword = "";
      addSignPos = newValue.indexOf("@");
      $scope.suggestions = [];
      if (addSignPos > -1  && addSignPos == newValue.length -1) {
        //show popout
        $scope.searchModal.show();
      }

      hashPos = newValue.indexOf("#",newValue.length-1);
      if (hashPos > -1 && hashPos == newValue.length -1 ) {
       $scope.channelModal.show();
      }
      
    });


    var timer;
    $scope.$watch("search.keyword", function(newValue, oldValue) {
      if (newValue && newValue.trim() !== '') {
        newValue = newValue.trim();
        oldValue = oldValue.trim();

        if (newValue != oldValue && newValue.length > 0) {
          $timeout.cancel(timer);
          if ($scope.search.keyword.length == 0) {
            return;
          }
          //start timer
          $scope.showLoading = true;
          timer = $timeout(function(){
            //start searching
            if (hashPos > -1) {
                ChannelCrud.searchall(newValue,function(data){
                  $scope.showLoading = false;
                  if (data.type == "OK") {
                    $scope.suggestions = data.channels;

                  }else{
                    $scope.message = data.message;  
                  }
                },true);

            }else{
                User.search(newValue,function(data){
                    $scope.showLoading = false;
                    if (data.type == "OK") {
                      $scope.suggestions = data.users;
                    }else{
                      $scope.message = data.message;  
                    }
                  });
              
            }
           }, 500);

        }
      }
    });

    
     $scope.getVideo = function(){
      return $scope.newMoment.image;
    };

    $scope.fillImage = function(){
      var coverPhoto = document.getElementById('coverPhoto');
      if($scope.newMoment.image.indexOf("data:image/jpeg;base64") < 0){
          coverPhoto.src = 'data:image/jpeg;base64,'+$scope.newMoment.image;
      }else{
          coverPhoto.src = $scope.newMoment.image;
      }
      
    };

    $scope.openCameraActionSheet = function(){
        var hideSheet = $ionicActionSheet.show({
          buttons: [
            { text: 'Use Camera' },
            { text: 'Upload Photo' } ,
            { text: 'Upload Video (Max 50Mb)' }
            
          ],
          cancelText: 'Cancel',
          cancel: function() {
          },
          buttonClicked: function(index) {
            if (navigator.camera) {
              var source = (index == 1 || index == 2)? navigator.camera.PictureSourceType.PHOTOLIBRARY : navigator.camera.PictureSourceType.CAMERA;
              if (index == 2) {
               $cordovaCamera.getPicture(Moments.getVdoOptions(source)).then(function(imageURI) {
                  imageURI = "file://" + imageURI;
                  navigator.createThumbnail(imageURI, function(err, imageData) {
                      if (!imageData) {
                        $scope.message = "Invalid file.";
                        return;
                      }
                      $scope.$apply(function () {
                          $scope.message = "";
                          $scope.newMoment.image = imageData;
                          $scope.newMoment.video = imageURI;
                          $scope.fillImage();
                      });
                      
                    });
               }, function(err) {
                  console.error(err);
               });
              }else{
                 $cordovaCamera.getPicture(Moments.getCameraOptions(source)).then(function(imageURI) {
                    // var coverPhoto = document.getElementById('coverPhoto');
                    // $scope.newMoment.image = imageURI;
                    // coverPhoto.src = 'data:image/jpeg;base64,'+imageURI;
                    $scope.newMoment.image = imageURI;
                }, function(err) {
                  console.error(err);
                });
              }

            } else {
              $scope.message = 'Unable to access camera. Are you on browser?';
            }
            return true;
          }
        });
    };

    //user select profile from mention
    $scope.showProfile = function(account) {
      $scope.searchModal.hide();
      var str = $scope.newMoment.description;
      
      $scope.newMoment.description = str.replace(/@([A-Za-z])*/gi,function make(x){
        return account.firstname + " " + account.lastname + " "; 
      });

      $scope.newMoment.mentions.push({
        "user_id" : account.id,
        "mention_text" : $scope.newMoment.description.substr(addSignPos),
        "start_position" : addSignPos,
        "end_position" : $scope.newMoment.description.length - 1
      });
      $scope.suggestions = [];
    };

    //user select channel from hash tag search
    $scope.viewChannel = function(channel){
      $scope.channelModal.hide();
      var strBefore = $scope.newMoment.description.substring(0,hashPos);
      var strAfter = $scope.newMoment.description.substring(hashPos);

      $scope.newMoment.description = strBefore + strAfter.replace(/#([A-Za-z0-9])*/gi,function make(x){
        return "#"+channel.name + " ";
      });

      $scope.newMoment.channels.push({
        "channel_id" : channel.id,
        "hash_text" : channel.name
      });
      $scope.suggestions = [];
    };

 
   
  $scope.tryCreate = function(){

    if ($scope.newMoment.video) {
        $scope.createMomentWithVdo();
        return;
    }

    $ionicLoading.show({
      template: '<i class="icon ion-loading-c"></i> Sharing moment..'
    });

    MomentCrud.create($scope.newMoment,function(data){
      $ionicLoading.hide();
      if (data.type == "OK") {
        $state.go('menu.tab.account');
        $scope.message = '';
        $rootScope.moments = Moments.add(data.moment);
        $scope.newMoment = {};

      }else{
        $scope.message = data.message;
      }
    });
  };

  $scope.createMomentWithVdo = function(){
      $ionicLoading.show({
        template: '<i class="icon ion-loading-c"></i> Uploading video...'
      });      
      var options = {"mimeType" : "video/mp4", "headers" : {"token" : LocalData.getToken()}};

      // console.log(VideoEditor);
      // var vdoEditorOptions = {
      //         fileUri: $scope.newMoment.video, // the path to the video on the device
      //         outputFileName: 'output-name', // the file name for the transcoded video
      //         quality: VideoEditorOptions.Quality.LOW_QUALITY,
      //         outputFileType: VideoEditorOptions.OutputFileType.MPEG4,
      //         optimizeForNetworkUse: VideoEditorOptions.OptimizeForNetworkUse.YES,
      //         duration: 60 , // optional, specify duration in seconds from start of video
      //         saveToLibrary: true, // optional, defaults to true
      //         deleteInputFile: false // optional (android only), defaults to false
      // };
      // // parameters passed to transcodeVideod
      // VideoEditor.transcodeVideo(function(result){
      //         console.log(result);
      //     },function(err){
      //         console.log(err);
      //     },vdoEditorOptions);

      // return;
      
      $cordovaFileTransfer.upload(GURILLA_URL + 'moments/videoupload',$scope.newMoment.video,options).then(function(data){
          $ionicLoading.hide();
          data = JSON.parse(data.response);
          if (data.type == "OK") {
            
            $scope.newMoment.video = data.file;

            $ionicLoading.show({
              template: '<i class="icon ion-loading-c"></i> Sharing moment...'
            });      

            MomentCrud.create($scope.newMoment,function(data){
              $ionicLoading.hide();
              if (data.type == "OK") {
                $state.go('menu.tab.account');
                $scope.message = '';
                $rootScope.moments = Moments.add(data.moment);
                $scope.newMoment = {};

              }else{
                $scope.message = data.message;
              }
            });   
          }else{
            $scope.message = data.message;
          }

      }, function(err){
          $ionicLoading.hide();
          $scope.message = "Error uploading file. Filesize might not be larger than 50Mb.";
      }, function(progressEvent){
          if (progressEvent.lengthComputable) {
            $scope.percent = Math.floor(progressEvent.loaded / progressEvent.total * 100);
          }
      });
  };
  
  // channels modal
  $ionicModal.fromTemplateUrl('templates/modal-event-tempdata.html', function($ionicModal) {
      $scope.modalTempData = $ionicModal;
  }, {
      scope: $scope,
      focusFirstInput: true,
      animation: 'slide-in-up'
  });

  //Circle search modal template
  $ionicModal.fromTemplateUrl('templates/modal-search-friends.html', function($ionicModal) {
    $scope.searchModal = $ionicModal;
  }, {
    scope: $scope,
    focusFirstInput: true,
    animation: 'slide-in-up'
  });

  $ionicModal.fromTemplateUrl('templates/modal-search-channels.html', function($ionicModal) {
    $scope.channelModal = $ionicModal;
    }, {
        scope: $scope,
        focusFirstInput: true,
        animation: 'slide-in-up'
  });

});

/**
* Moment Photo Detail Controller 
* State : menu.tab.account-photo
* Template : templates/social-photo-detail.html 
**/
app.controller('MomentPhotoCtrl', function ($rootScope,$scope,$state,$stateParams,$ionicLoading,$anchorScroll,$timeout,$ionicHistory,
  $ionicScrollDelegate,$ionicPopup,$ionicPopover,Moments,MomentCrud,LocalData,CommentCrud,Contacts,Channels,ChannelCrud, Helper) {
    
$scope.account = $stateParams.account;

  //firend account object has profile array but own profile account 
  if (!$scope.account.profile) {
    $scope.account.profile = [];
    $scope.account.profile.photo = $scope.account.photo;
  }

  $scope.moment = $stateParams.moment;
  var social_id = $scope.moment.social_id;

  $scope.newComment = {
    content : ""
  };

  $scope.comments = $scope.moment.comments;
  $scope.moment.number_of_likes = parseInt($scope.moment.number_of_likes);

  if ($scope.moment.mentions && typeof $scope.moment.mentions == "string" ) {
    $scope.moment.mentions = JSON.parse($scope.moment.mentions);
  }


  if ($scope.moment.channels && typeof $scope.moment.channels == "string") {
    $scope.moment.channels = JSON.parse($scope.moment.channels);
  }

  var str = ""; 
  var pos = 0;

  $scope.desc = $scope.moment.description;
  $scope.moment.created_at = Helper.getTime($scope.moment.created_at);


  angular.forEach($scope.moment.mentions, function(value, key){
    $scope.desc = $scope.desc.replace(value["mention_text"],function make(x){
      return "<a href='#' ng-click=goToProfile('"+value.user_id+"')>@"+value.mention_text+"</a>";
    });
  });

  angular.forEach($scope.moment.channels, function(value, key){
   $scope.desc = $scope.desc.replace("#"+value["hash_text"],function make(x){
      return "<a href='#' ng-click=goToChannel('"+value.channel_id+"')>#"+value.hash_text+"</a>";
    });
  });

  $scope.goToChannel = function(channel_id){
    var channel = Channels.findChannelById(channel_id);
    if (channel) {
      if (Channels.findChannelType(channel) === "created") {
        $state.go('menu.tab.account-channel-manage',{"channel":channel,"type":"created"});
      }else{
        $state.go('menu.tab.account-channel-detail',{"channel" : channel});
      }
    }else{
      //if not in both joined or created 
      // call from network
      $ionicLoading.show({
        template: '<i class="icon ion-loading-c"></i> Loading...'
      });

     ChannelCrud.detail({"id":channel_id} , function(data){
      $ionicLoading.hide();
        if(data.type == "OK"){
            $state.go('menu.tab.account-channel-detail',{"channel" : data.channel});
        }
      });
    }
  };

  $scope.goToProfile = function(user_id){
    if (Contacts.isMe(user_id)) {
      $state.go("menu.tab.account");
    }else{
      $state.go("menu.tab.account-friend-profile",{accountID : user_id});
    }
  };

  $scope.isMe = function(id){
    return Contacts.isMe(id);
   };

  // $scope.getAllComments = function(page){
  //   if (page === null) return;
  //   $ionicLoading.show({
  //     template: '<i class="icon ion-loading-c"></i> Loading...'
  //   });
  //   CommentCrud.read(social_id,page,function(data){
  //     $ionicLoading.hide();  
  //     if(data.type == "OK"){
  //       $scope.comments = data.comments.result;
  //       $scope.$broadcast('scroll.infiniteScrollComplete');
  //     }
  //   });
  // };

  $scope.toggleLike = function(){
    $ionicLoading.show({
      template: '<i class="icon ion-loading-c"></i> loading...'
   });

   if($scope.moment.has_like){
      CommentCrud.removeLike(social_id,function(data){
        $ionicLoading.hide();  
        if(data.type == "OK"){
          $scope.moment.number_of_likes = parseInt($scope.moment.number_of_likes) - 1;
          $scope.moment.has_like = false;
        }
      });
   }else{
     CommentCrud.addLike(social_id,function(data){
        $ionicLoading.hide();  
        if(data.type == "OK"){
          $scope.moment.number_of_likes = parseInt($scope.moment.number_of_likes) + 1;
           $scope.moment.has_like = true;
        }
      });
   }

  };


  $scope.removeMoment = function(){
    $scope.popover.hide();

    console.log("Moment to remove");
    console.log($scope.moment);

    var confirmPopup = $ionicPopup.confirm({
       title: 'Delete Moment',
       template: 'You are about to delete the moment ?'
     });

   
     //delete circle if user click okay
     confirmPopup.then(function(res) {
        if (res) {
            $ionicLoading.show({
              template: '<i class="icon ion-loading-c"></i> Deleting moment...'
            });

            //for moments inside channel can not be delete directly 
            //Channel owner can only hide moments
            if ($stateParams.extra && $stateParams.extra.from === "channel") {
                //hide moments
                MomentCrud.hide($scope.moment.id, $stateParams.extra.channel_id, function(data){
                    $ionicLoading.hide();
                    if (data.type == "OK") {
                      $scope.message = '';
                      Moments.remove("channel", $stateParams.extra.channel_id, $scope.moment.id);
                      $state.go($rootScope.prevState, $rootScope.prevParams, {reload: true});
                    }else{
                      $scope.message = data.message;
                    }
                });

            }else{
              MomentCrud.delete($scope.moment.id,function(data){
                  $ionicLoading.hide();
                  if (data.type == "OK") {
                    $scope.message = '';
                    $state.go($rootScope.prevState, $rootScope.prevParams, {reload: true});
                  }else{
                    $scope.message = data.message;
                  }
              });  
            }
        }

     });
  };

  $scope.addComment = function(){
   $ionicLoading.show({
      template: '<i class="icon ion-loading-c"></i> Posting...'
   });

   CommentCrud.create(social_id,$scope.newComment,function(data){
      $ionicLoading.hide();  
      if(data.type == "OK"){
        $scope.comments.push(data.comment);
        $scope.newComment = {};
      }
    });
  };

  $scope.loadmore = function(){
    $scope.getAllComments($scope.photo.comments.next);
  };

  $scope.canloadmore = function(){
    if ($scope.photo.comments){
      return ($scope.photo.comments.comment_count > $scope.comments.length);
    }
  };

  $scope.showProfile = function(user) {
    if(Contacts.isMe(user.id)){
        $state.go("menu.tab.account");
      }else{
        $state.go("menu.tab.account-friend-profile",{accountID : user.id});
      }
  };

  $scope.removeComment = function(comment){
    var confirmPopup = $ionicPopup.confirm({
       title: 'Delete Comment',
       template: 'You are about to delete the comment ?'
     });
     //delete circle if user click okay
     confirmPopup.then(function(res) {
        if (res) {
            var index = $scope.comments.indexOf(comment);
            $scope.comments.splice(index,1);
            CommentCrud.delete(social_id,comment.id,function(data){
              if (data.type == "OK") {
                $scope.message = '';
              }else{
                $scope.message = data.message;
              }
          });

        }

     });
  };

  $scope.canRemove = function(id){
      var user = JSON.parse(LocalData.get('account'));
      if (user.id == id || $stateParams.access ) {
        return true;
      }else{
        return false;
      }
      
  };

  $scope.showActions = function($event){
    $scope.popover.show($event);  
  };

  $scope.gotoAddPost = function() {
    // set the location.hash to the id of
    // the element you wish to scroll to.
   // $ionicScrollDelegate.scrollBottom();
  };

  $timeout(function(){
    $scope.gotoAddPost();
  });

  $ionicPopover.fromTemplateUrl('templates/popover-social-photo-detail.html', {
    scope: $scope
  }).then(function(popover) {
    $scope.popover = popover;
  });

});

